/* Generated by re2c 0.13.5 on Wed Mar 11 14:42:24 2009 */
#line 1 "Zend/zend_language_scanner.l"
/*
   +----------------------------------------------------------------------+
   | Zend Engine                                                          |
   +----------------------------------------------------------------------+
   | Copyright (c) 1998-2009 Zend Technologies Ltd. (http://www.zend.com) |
   +----------------------------------------------------------------------+
   | This source file is subject to version 2.00 of the Zend license,     |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.zend.com/license/2_00.txt.                                |
   | If you did not receive a copy of the Zend license and are unable to  |
   | obtain it through the world-wide-web, please send a note to          |
   | license@zend.com so we can mail you a copy immediately.              |
   +----------------------------------------------------------------------+
   | Authors: Marcus Boerger <helly@php.net>                              |
   |          Nuno Lopes <nlopess@php.net>                                |
   |          Scott MacVicar <scottmac@php.net>                           |
   | Flex version authors:                                                |
   |          Andi Gutmans <andi@zend.com>                                |
   |          Zeev Suraski <zeev@zend.com>                                |
   +----------------------------------------------------------------------+
*/

/* $Id: zend_language_scanner.c,v 1.1.2.34 2009/03/11 22:11:50 shire Exp $ */

#if 0
# define YYDEBUG(s, c) printf("state: %d char: %c\n", s, c)
#else
# define YYDEBUG(s, c)
#endif

#include "zend_language_scanner_defs.h"

#include <errno.h>
#include "zend.h"
#include "zend_alloc.h"
#include <zend_language_parser.h>
#include "zend_compile.h"
#include "zend_language_scanner.h"
#include "zend_highlight.h"
#include "zend_constants.h"
#include "zend_variables.h"
#include "zend_operators.h"
#include "zend_API.h"
#include "zend_strtod.h"
#include "zend_exceptions.h"
#include "tsrm_virtual_cwd.h"
#include "tsrm_config_common.h"

#define YYCTYPE   unsigned char
#define YYFILL(n) { if ((YYCURSOR + n) >= (YYLIMIT + ZEND_MMAP_AHEAD)) { zend_error(E_COMPILE_ERROR, "Exceeded YYLIMIT bounds during scanning.  Please report this."); return 0; } }
#define YYCURSOR  SCNG(yy_cursor)
#define YYLIMIT   SCNG(yy_limit)
#define YYMARKER  SCNG(yy_marker)

#define YYGETCONDITION()  SCNG(yy_state)
#define YYSETCONDITION(s) SCNG(yy_state) = s

#define STATE(name)  yyc##name

/* emulate flex constructs */
#define BEGIN(state) YYSETCONDITION(STATE(state))
#define YYSTATE      YYGETCONDITION()
#define yytext       ((char*)SCNG(yy_text))
#define yyleng       SCNG(yy_leng)
#define yyless(x)    do { YYCURSOR = (unsigned char*)yytext + x; \
                          yyleng   = (unsigned int)x; } while(0)
#define yymore()     goto yymore_restart

/* perform sanity check. If this message is triggered you should
   increase the ZEND_MMAP_AHEAD value in the zend_streams.h file */
#define YYMAXFILL 16
#if ZEND_MMAP_AHEAD < YYMAXFILL
# error ZEND_MMAP_AHEAD should be greater than or equal to YYMAXFILL
#endif

#ifdef HAVE_STDARG_H
# include <stdarg.h>
#endif

#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif

/* Globals Macros */
#define SCNG	LANG_SCNG
#ifdef ZTS
ZEND_API ts_rsrc_id language_scanner_globals_id;
#else
ZEND_API zend_php_scanner_globals language_scanner_globals;
#endif

#define HANDLE_NEWLINES(s, l)													\
do {																			\
	char *p = (s), *boundary = p+(l);											\
																				\
	while (p<boundary) {														\
		if (*p == '\n' || (*p == '\r' && (*(p+1) != '\n'))) {					\
			CG(zend_lineno)++;													\
		}																		\
		p++;																	\
	}																			\
} while (0)

#define HANDLE_NEWLINE(c) \
{ \
	if (c == '\n' || c == '\r') { \
		CG(zend_lineno)++; \
	} \
}

#define ZEND_IS_OCT(c)  ((c)>='0' && (c)<='7')
#define ZEND_IS_HEX(c)  (((c)>='0' && (c)<='9') || ((c)>='a' && (c)<='f') || ((c)>='A' && (c)<='F'))

BEGIN_EXTERN_C()

static void _yy_push_state(int new_state TSRMLS_DC)
{
	zend_stack_push(&SCNG(state_stack), (void *) &YYGETCONDITION(), sizeof(int));
	YYSETCONDITION(new_state);
}

#define yy_push_state(state_and_tsrm) _yy_push_state(yyc##state_and_tsrm)

static void yy_pop_state(TSRMLS_D)
{
	int *stack_state;
	zend_stack_top(&SCNG(state_stack), (void **) &stack_state);
	YYSETCONDITION(*stack_state);
	zend_stack_del_top(&SCNG(state_stack));
}

static void yy_scan_buffer(char *str, unsigned int len TSRMLS_DC)
{
	YYCURSOR       = (YYCTYPE*)str;
	SCNG(yy_start) = YYCURSOR;
	YYLIMIT        = YYCURSOR + len;
}

void startup_scanner(TSRMLS_D)
{
	CG(heredoc) = NULL;
	CG(heredoc_len) = 0;
	CG(doc_comment) = NULL;
	CG(doc_comment_len) = 0;
	zend_llist_init(&SCNG(used_state_stacks), sizeof(zend_stack), (llist_dtor_func_t) zend_stack_destroy, 0);
	zend_stack_init(&SCNG(state_stack));
	zend_llist_add_element(&SCNG(used_state_stacks), &SCNG(state_stack));
}

void shutdown_scanner(TSRMLS_D)
{
	if (CG(heredoc)) {
		efree(CG(heredoc));
		CG(heredoc_len)=0;
	}
	zend_llist_destroy(&SCNG(used_state_stacks));
	RESET_DOC_COMMENT();
}

static int compare_stacks(zend_stack *stack1, zend_stack *stack2)
{
	return (stack1 == stack2);
}

ZEND_API void zend_save_lexical_state(zend_lex_state *lex_state TSRMLS_DC)
{
	lex_state->yy_leng   = SCNG(yy_leng);
	lex_state->yy_start  = SCNG(yy_start);
	lex_state->yy_text   = SCNG(yy_text);
	lex_state->yy_cursor = SCNG(yy_cursor);
	lex_state->yy_marker = SCNG(yy_marker);
	lex_state->yy_limit  = SCNG(yy_limit);

	lex_state->state_stack = SCNG(state_stack);
	zend_stack_init(&SCNG(state_stack));
	zend_llist_add_element(&SCNG(used_state_stacks), &SCNG(state_stack));

	lex_state->in = SCNG(yy_in);
	lex_state->yy_state = YYSTATE;
	lex_state->filename = zend_get_compiled_filename(TSRMLS_C);
	lex_state->lineno = CG(zend_lineno);

#ifdef ZEND_MULTIBYTE
	lex_state->script_org = SCNG(script_org);
	lex_state->script_org_size = SCNG(script_org_size);
	lex_state->script_filtered = SCNG(script_filtered);
	lex_state->script_filtered_size = SCNG(script_filtered_size);
	lex_state->input_filter = SCNG(input_filter);
	lex_state->output_filter = SCNG(output_filter);
	lex_state->script_encoding = SCNG(script_encoding);
	lex_state->internal_encoding = SCNG(internal_encoding);
#endif /* ZEND_MULTIBYTE */
}

ZEND_API void zend_restore_lexical_state(zend_lex_state *lex_state TSRMLS_DC)
{
	SCNG(yy_leng)   = lex_state->yy_leng;
	SCNG(yy_start)  = lex_state->yy_start;
	SCNG(yy_text)   = lex_state->yy_text;
	SCNG(yy_cursor) = lex_state->yy_cursor;
	SCNG(yy_marker) = lex_state->yy_marker;
	SCNG(yy_limit)  = lex_state->yy_limit;

	zend_llist_del_element(&SCNG(used_state_stacks), &SCNG(state_stack), (int (*)(void *, void *)) compare_stacks);
	SCNG(state_stack) = lex_state->state_stack;

	SCNG(yy_in) = lex_state->in;
	YYSETCONDITION(lex_state->yy_state);
	CG(zend_lineno) = lex_state->lineno;
	zend_restore_compiled_filename(lex_state->filename TSRMLS_CC);
#ifdef ZEND_MULTIBYTE
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
		SCNG(script_org) = NULL;
	}
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
	SCNG(script_org) = lex_state->script_org;
	SCNG(script_org_size) = lex_state->script_org_size;
	SCNG(script_filtered) = lex_state->script_filtered;
	SCNG(script_filtered_size) = lex_state->script_filtered_size;
	SCNG(input_filter) = lex_state->input_filter;
	SCNG(output_filter) = lex_state->output_filter;
	SCNG(script_encoding) = lex_state->script_encoding;
	SCNG(internal_encoding) = lex_state->internal_encoding;
#endif /* ZEND_MULTIBYTE */
}

ZEND_API void zend_destroy_file_handle(zend_file_handle *file_handle TSRMLS_DC)
{
	zend_llist_del_element(&CG(open_files), file_handle, (int (*)(void *, void *)) zend_compare_file_handles);
	/* zend_file_handle_dtor() operates on the copy, so we have to NULLify the original here */
	file_handle->opened_path = NULL;
	if (file_handle->free_filename) {
		file_handle->filename = NULL;
	}
}


ZEND_API int open_file_for_scanning(zend_file_handle *file_handle TSRMLS_DC)
{
	char *file_path = NULL, *buf;
	size_t size;

	if (zend_stream_fixup(file_handle, &buf, &size TSRMLS_CC) == FAILURE) {
		return FAILURE;
	}

	zend_llist_add_element(&CG(open_files), file_handle);
	if (file_handle->handle.stream.handle >= (void*)file_handle && file_handle->handle.stream.handle <= (void*)(file_handle+1)) {
		zend_file_handle *fh = (zend_file_handle*)zend_llist_get_last(&CG(open_files));
		size_t diff = (char*)file_handle->handle.stream.handle - (char*)file_handle;
		fh->handle.stream.handle = (void*)(((char*)fh) + diff);
		file_handle->handle.stream.handle = fh->handle.stream.handle;
	}

	/* Reset the scanner for scanning the new file */
	SCNG(yy_in) = file_handle;

	if (size != -1) {
#ifdef ZEND_MULTIBYTE
		if (zend_multibyte_read_script((unsigned char *)buf, size TSRMLS_CC) != 0) {
			return FAILURE;
		}

		SCNG(yy_in) = NULL;

		zend_multibyte_set_filter(NULL TSRMLS_CC);

		if (!SCNG(input_filter)) {
			SCNG(script_filtered) = (unsigned char*)emalloc(SCNG(script_org_size)+1);
			memcpy(SCNG(script_filtered), SCNG(script_org), SCNG(script_org_size)+1);
			SCNG(script_filtered_size) = SCNG(script_org_size);
		} else {
			SCNG(input_filter)(&SCNG(script_filtered), &SCNG(script_filtered_size), SCNG(script_org), SCNG(script_org_size) TSRMLS_CC);
		}

		yy_scan_buffer((char *)SCNG(script_filtered), SCNG(script_filtered_size) TSRMLS_CC);
#else /* !ZEND_MULTIBYTE */
		yy_scan_buffer(buf, size TSRMLS_CC);
#endif /* ZEND_MULTIBYTE */
	} else {
		zend_error_noreturn(E_COMPILE_ERROR, "zend_stream_mmap() failed");
	}

	BEGIN(INITIAL);

	if (file_handle->opened_path) {
		file_path = file_handle->opened_path;
	} else {
		file_path = file_handle->filename;
	}

	zend_set_compiled_filename(file_path TSRMLS_CC);

	if (CG(start_lineno)) {
		CG(zend_lineno) = CG(start_lineno);
		CG(start_lineno) = 0;
	} else {
		CG(zend_lineno) = 1;
	}

	CG(increment_lineno) = 0;
	return SUCCESS;
}
END_EXTERN_C()


ZEND_API zend_op_array *compile_file(zend_file_handle *file_handle, int type TSRMLS_DC)
{
	zend_lex_state original_lex_state;
	zend_op_array *op_array = (zend_op_array *) emalloc(sizeof(zend_op_array));
	zend_op_array *original_active_op_array = CG(active_op_array);
	zend_op_array *retval=NULL;
	int compiler_result;
	zend_bool compilation_successful=0;
	znode retval_znode;
	zend_bool original_in_compilation = CG(in_compilation);

	retval_znode.op_type = IS_CONST;
	retval_znode.u.constant.type = IS_LONG;
	retval_znode.u.constant.value.lval = 1;
	Z_UNSET_ISREF(retval_znode.u.constant);
	Z_SET_REFCOUNT(retval_znode.u.constant, 1);

	zend_save_lexical_state(&original_lex_state TSRMLS_CC);

	retval = op_array; /* success oriented */

	if (open_file_for_scanning(file_handle TSRMLS_CC)==FAILURE) {
		if (type==ZEND_REQUIRE) {
			zend_message_dispatcher(ZMSG_FAILED_REQUIRE_FOPEN, file_handle->filename TSRMLS_CC);
			zend_bailout();
		} else {
			zend_message_dispatcher(ZMSG_FAILED_INCLUDE_FOPEN, file_handle->filename TSRMLS_CC);
		}
		compilation_successful=0;
	} else {
		init_op_array(op_array, ZEND_USER_FUNCTION, INITIAL_OP_ARRAY_SIZE TSRMLS_CC);
		CG(in_compilation) = 1;
		CG(active_op_array) = op_array;
		compiler_result = zendparse(TSRMLS_C);
		zend_do_return(&retval_znode, 0 TSRMLS_CC);
		CG(in_compilation) = original_in_compilation;
		if (compiler_result==1) { /* parser error */
			zend_bailout();
		}
		compilation_successful=1;
	}

	if (retval) {
		CG(active_op_array) = original_active_op_array;
		if (compilation_successful) {
			pass_two(op_array TSRMLS_CC);
			zend_release_labels(TSRMLS_C);
		} else {
			efree(op_array);
			retval = NULL;
		}
	}
	if (compilation_successful) {
		zend_restore_lexical_state(&original_lex_state TSRMLS_CC);
	}
	return retval;
}


zend_op_array *compile_filename(int type, zval *filename TSRMLS_DC)
{
	zend_file_handle file_handle;
	zval tmp;
	zend_op_array *retval;
	char *opened_path = NULL;

	if (filename->type != IS_STRING) {
		tmp = *filename;
		zval_copy_ctor(&tmp);
		convert_to_string(&tmp);
		filename = &tmp;
	}
	file_handle.filename = filename->value.str.val;
	file_handle.free_filename = 0;
	file_handle.type = ZEND_HANDLE_FILENAME;
	file_handle.opened_path = NULL;
	file_handle.handle.fp = NULL;

	retval = zend_compile_file(&file_handle, type TSRMLS_CC);
	if (retval && file_handle.handle.stream.handle) {
		int dummy = 1;

		if (!file_handle.opened_path) {
			file_handle.opened_path = opened_path = estrndup(filename->value.str.val, filename->value.str.len);
		}

		zend_hash_add(&EG(included_files), file_handle.opened_path, strlen(file_handle.opened_path)+1, (void *)&dummy, sizeof(int), NULL);

		if (opened_path) {
			efree(opened_path);
		}
	}
	zend_destroy_file_handle(&file_handle TSRMLS_CC);

	if (filename==&tmp) {
		zval_dtor(&tmp);
	}
	return retval;
}

ZEND_API int zend_prepare_string_for_scanning(zval *str, char *filename TSRMLS_DC)
{
	/* enforce two trailing NULLs for flex... */
	str->value.str.val = safe_erealloc(str->value.str.val, 1, str->value.str.len, ZEND_MMAP_AHEAD);

	memset(str->value.str.val + str->value.str.len, 0, ZEND_MMAP_AHEAD);

	SCNG(yy_in)=NULL;

#ifdef ZEND_MULTIBYTE
	SCNG(script_org) = (unsigned char *)estrdup(str->value.str.val);
	SCNG(script_org_size) = str->value.str.len;

	zend_multibyte_set_filter(CG(internal_encoding) TSRMLS_CC);

	if (!SCNG(input_filter)) {
		SCNG(script_filtered) = (unsigned char*)emalloc(SCNG(script_org_size)+1);
		memcpy(SCNG(script_filtered), SCNG(script_org), SCNG(script_org_size)+1);
		SCNG(script_filtered_size) = SCNG(script_org_size);
	} else {
		SCNG(input_filter)(&SCNG(script_filtered), &SCNG(script_filtered_size), SCNG(script_org), SCNG(script_org_size) TSRMLS_CC);
	}

	yy_scan_buffer((char *)SCNG(script_filtered), SCNG(script_filtered_size) TSRMLS_CC);	
#else /* !ZEND_MULTIBYTE */
	yy_scan_buffer(str->value.str.val, str->value.str.len TSRMLS_CC);
#endif /* ZEND_MULTIBYTE */

	zend_set_compiled_filename(filename TSRMLS_CC);
	CG(zend_lineno) = 1;
	CG(increment_lineno) = 0;
	return SUCCESS;
}


ZEND_API size_t zend_get_scanned_file_offset(TSRMLS_D)
{
	size_t offset = SCNG(yy_cursor) - SCNG(yy_start);
#ifdef ZEND_MULTIBYTE
	if (SCNG(input_filter)) {
		size_t original_offset = offset, length = 0; do {
			unsigned char *p = NULL;
			SCNG(input_filter)(&p, &length, SCNG(script_org), offset TSRMLS_CC);
			if (!p) {
				break;
			}
			efree(p);
			if (length > original_offset) {
				offset--;
			} else if (length < original_offset) {
				offset++;
			}
		} while (original_offset != length);
	}
#endif
	return offset;
}


zend_op_array *compile_string(zval *source_string, char *filename TSRMLS_DC)
{
	zend_lex_state original_lex_state;
	zend_op_array *op_array = (zend_op_array *) emalloc(sizeof(zend_op_array));
	zend_op_array *original_active_op_array = CG(active_op_array);
	zend_op_array *retval;
	zval tmp;
	int compiler_result;
	zend_bool original_in_compilation = CG(in_compilation);

	if (source_string->value.str.len==0) {
		efree(op_array);
		return NULL;
	}

	CG(in_compilation) = 1;

	tmp = *source_string;
	zval_copy_ctor(&tmp);
	convert_to_string(&tmp);
	source_string = &tmp;

	zend_save_lexical_state(&original_lex_state TSRMLS_CC);
	if (zend_prepare_string_for_scanning(source_string, filename TSRMLS_CC)==FAILURE) {
		efree(op_array);
		retval = NULL;
	} else {
		zend_bool orig_interactive = CG(interactive);

		CG(interactive) = 0;
		init_op_array(op_array, ZEND_EVAL_CODE, INITIAL_OP_ARRAY_SIZE TSRMLS_CC);
		CG(interactive) = orig_interactive;
		CG(active_op_array) = op_array;
		BEGIN(ST_IN_SCRIPTING);
		compiler_result = zendparse(TSRMLS_C);

#ifdef ZEND_MULTIBYTE
		if (SCNG(script_org)) {
			efree(SCNG(script_org));
			SCNG(script_org) = NULL;
		}
		if (SCNG(script_filtered)) {
			efree(SCNG(script_filtered));
			SCNG(script_filtered) = NULL;
		}
#endif /* ZEND_MULTIBYTE */

		if (compiler_result==1) {
			CG(active_op_array) = original_active_op_array;
			CG(unclean_shutdown)=1;
			retval = NULL;
		} else {
			zend_do_return(NULL, 0 TSRMLS_CC);
			CG(active_op_array) = original_active_op_array;
			pass_two(op_array TSRMLS_CC);
			zend_release_labels(TSRMLS_C);
			retval = op_array;
		}
		zend_restore_lexical_state(&original_lex_state TSRMLS_CC);
	}
	zval_dtor(&tmp);
	CG(in_compilation) = original_in_compilation;
	return retval;
}


BEGIN_EXTERN_C()
int highlight_file(char *filename, zend_syntax_highlighter_ini *syntax_highlighter_ini TSRMLS_DC)
{
	zend_lex_state original_lex_state;
	zend_file_handle file_handle;

	file_handle.type = ZEND_HANDLE_FILENAME;
	file_handle.filename = filename;
	file_handle.free_filename = 0;
	file_handle.opened_path = NULL;
	zend_save_lexical_state(&original_lex_state TSRMLS_CC);
	if (open_file_for_scanning(&file_handle TSRMLS_CC)==FAILURE) {
		zend_message_dispatcher(ZMSG_FAILED_HIGHLIGHT_FOPEN, filename TSRMLS_CC);
		return FAILURE;
	}
	zend_highlight(syntax_highlighter_ini TSRMLS_CC);
#ifdef ZEND_MULTIBYTE
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
		SCNG(script_org) = NULL;
	}
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
#endif /* ZEND_MULTIBYTE */
	zend_destroy_file_handle(&file_handle TSRMLS_CC);
	zend_restore_lexical_state(&original_lex_state TSRMLS_CC);
	return SUCCESS;
}

int highlight_string(zval *str, zend_syntax_highlighter_ini *syntax_highlighter_ini, char *str_name TSRMLS_DC)
{
	zend_lex_state original_lex_state;
	zval tmp = *str;

	str = &tmp;
	zval_copy_ctor(str);
	zend_save_lexical_state(&original_lex_state TSRMLS_CC);
	if (zend_prepare_string_for_scanning(str, str_name TSRMLS_CC)==FAILURE) {
		return FAILURE;
	}
	BEGIN(INITIAL);
	zend_highlight(syntax_highlighter_ini TSRMLS_CC);
#ifdef ZEND_MULTIBYTE
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
		SCNG(script_org) = NULL;
	}
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
#endif /* ZEND_MULTIBYTE */
	zend_restore_lexical_state(&original_lex_state TSRMLS_CC);
	zval_dtor(str);
	return SUCCESS;
}
END_EXTERN_C()

#ifdef ZEND_MULTIBYTE

BEGIN_EXTERN_C()
ZEND_API void zend_multibyte_yyinput_again(zend_encoding_filter old_input_filter, zend_encoding *old_encoding TSRMLS_DC)
{
	size_t original_offset, offset, free_flag, new_len, length;
	unsigned char *p;

	/* calculate current position */
	offset = original_offset = YYCURSOR - SCNG(yy_start);
	if (old_input_filter && offset > 0) {
		zend_encoding *new_encoding = SCNG(script_encoding);
		zend_encoding_filter new_filter = SCNG(input_filter);
		SCNG(script_encoding) = old_encoding;
		SCNG(input_filter) = old_input_filter;
		offset = zend_get_scanned_file_offset(TSRMLS_C);
		SCNG(script_encoding) = new_encoding;
		SCNG(input_filter) = new_filter;
	}

	/* convert and set */
	if (!SCNG(input_filter)) {
		length = SCNG(script_org_size) - offset;
		p = SCNG(script_org) + offset;
		free_flag = 0;
	} else {
		SCNG(input_filter)(&p, &length, SCNG(script_org) + offset, SCNG(script_org_size) - offset TSRMLS_CC);
		free_flag = 1;
	}

	new_len = original_offset + length;

	if (new_len > YYLIMIT - SCNG(yy_start)) {
		unsigned char *new_yy_start = erealloc(SCNG(yy_start), new_len);
		SCNG(yy_cursor) = new_yy_start + (SCNG(yy_cursor) - SCNG(yy_start));
		SCNG(yy_marker) = new_yy_start + (SCNG(yy_marker) - SCNG(yy_start));
		SCNG(yy_text) = new_yy_start + (SCNG(yy_text) - SCNG(yy_start));
		SCNG(yy_start) = new_yy_start;
		SCNG(script_filtered) = new_yy_start;
		SCNG(script_filtered_size) = new_len;
	}

	SCNG(yy_limit) = SCNG(yy_start) + new_len;
	memmove(SCNG(yy_start) + original_offset, p, length);

	if (free_flag) {
		efree(p);
	}
}


ZEND_API int zend_multibyte_yyinput(zend_file_handle *file_handle, char *buf, size_t len TSRMLS_DC)
{
	size_t n;

	if (CG(interactive) == 0) {
		if (zend_stream_fixup(file_handle, &buf, &len TSRMLS_CC) == FAILURE) {
			return FAILURE;
		}
		n = len;
		return n;
	}

	/* interactive */
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
	}
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
	}
	SCNG(script_org) = NULL;
	SCNG(script_org_size) = 0;

	/* TODO: support widechars */
	if (zend_stream_fixup(file_handle, &buf, &len TSRMLS_CC) == FAILURE) {
		return FAILURE;
	}
	n = len;

	SCNG(script_org_size) = n;
	SCNG(script_org) = (unsigned char*)emalloc(SCNG(script_org_size) + 1);
	memcpy(SCNG(script_org), buf, n);

	return n;
}


ZEND_API int zend_multibyte_read_script(unsigned char *buf, size_t n TSRMLS_DC)
{
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
	}
	SCNG(script_org_size) = n;
	SCNG(script_org) = (unsigned char*)erealloc(SCNG(script_org), SCNG(script_org_size));
	memcpy(SCNG(script_org) + SCNG(script_org_size) - n, buf, n);
	
	SCNG(script_org) = (unsigned char*)erealloc(SCNG(script_org), SCNG(script_org_size) + 1);
	*(SCNG(script_org)+SCNG(script_org_size)) = '\0';

	return 0;
}


# define zend_copy_value(zendlval, yytext, yyleng) \
	if (SCNG(output_filter)) { \
		size_t sz = 0; \
		SCNG(output_filter)((unsigned char **)&(zendlval->value.str.val), &sz, (unsigned char *)yytext, (size_t)yyleng TSRMLS_CC); \
		zendlval->value.str.len = sz; \
	} else { \
		zendlval->value.str.val = (char *) estrndup(yytext, yyleng); \
		zendlval->value.str.len = yyleng; \
	}
#else /* ZEND_MULTIBYTE */
# define zend_copy_value(zendlval, yytext, yyleng) \
	zendlval->value.str.val = (char *)estrndup(yytext, yyleng); \
	zendlval->value.str.len = yyleng;
#endif /* ZEND_MULTIBYTE */

static void zend_scan_escape_string(zval *zendlval, char *str, int len, char quote_type TSRMLS_DC)
{
	register char *s, *t;
	char *end;

	ZVAL_STRINGL(zendlval, str, len, 1);

	/* convert escape sequences */
	s = t = zendlval->value.str.val;
	end = s+zendlval->value.str.len;
	while (s<end) {
		if (*s=='\\') {
			s++;
			if (s >= end) {
				*t++ = '\\';
				break;
			}

			switch(*s) {
				case 'n':
					*t++ = '\n';
					zendlval->value.str.len--;
					break;
				case 'r':
					*t++ = '\r';
					zendlval->value.str.len--;
					break;
				case 't':
					*t++ = '\t';
					zendlval->value.str.len--;
					break;
				case 'f':
					*t++ = '\f';
					zendlval->value.str.len--;
					break;
				case 'v':
					*t++ = '\v';
					zendlval->value.str.len--;
					break;
				case '"':
				case '`':
					if (*s != quote_type) {
						*t++ = '\\';
						*t++ = *s;
						break;
					}
				case '\\':
				case '$':
					*t++ = *s;
					zendlval->value.str.len--;
					break;
				case 'x':
				case 'X':
					if (ZEND_IS_HEX(*(s+1))) {
						char hex_buf[3] = { 0, 0, 0 };

						zendlval->value.str.len--; /* for the 'x' */

						hex_buf[0] = *(++s);
						zendlval->value.str.len--;
						if (ZEND_IS_HEX(*(s+1))) {
							hex_buf[1] = *(++s);
							zendlval->value.str.len--;
						}
						*t++ = (char) strtol(hex_buf, NULL, 16);
					} else {
						*t++ = '\\';
						*t++ = *s;
					}
					break;
				default:
					/* check for an octal */
					if (ZEND_IS_OCT(*s)) {
						char octal_buf[4] = { 0, 0, 0, 0 };

						octal_buf[0] = *s;
						zendlval->value.str.len--;
						if (ZEND_IS_OCT(*(s+1))) {
							octal_buf[1] = *(++s);
							zendlval->value.str.len--;
							if (ZEND_IS_OCT(*(s+1))) {
								octal_buf[2] = *(++s);
								zendlval->value.str.len--;
							}
						}
						*t++ = (char) strtol(octal_buf, NULL, 8);
					} else {
						*t++ = '\\';
						*t++ = *s;
					}
					break;
			}
		} else {
			*t++ = *s;
		}

		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
	}
	*t = 0;
#ifdef ZEND_MULTIBYTE
	if (SCNG(output_filter)) {
		size_t sz = 0;
		s = zendlval->value.str.val;
		SCNG(output_filter)((unsigned char **)&(zendlval->value.str.val), &sz, (unsigned char *)s, (size_t)zendlval->value.str.len TSRMLS_CC);
		zendlval->value.str.len = sz;
		efree(s);
	}
#endif /* ZEND_MULTIBYTE */
}


int lex_scan(zval *zendlval TSRMLS_DC)
{
restart:
	SCNG(yy_text) = YYCURSOR;

yymore_restart:


#line 840 "Zend/zend_language_scanner.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	if (YYGETCONDITION() < 6) {
		if (YYGETCONDITION() < 3) {
			if (YYGETCONDITION() < 1) {
				goto yyc_ST_IN_SCRIPTING;
			} else {
				if (YYGETCONDITION() < 2) {
					goto yyc_ST_LOOKING_FOR_PROPERTY;
				} else {
					goto yyc_ST_BACKQUOTE;
				}
			}
		} else {
			if (YYGETCONDITION() < 4) {
				goto yyc_ST_DOUBLE_QUOTES;
			} else {
				if (YYGETCONDITION() < 5) {
					goto yyc_ST_HEREDOC;
				} else {
					goto yyc_ST_LOOKING_FOR_VARNAME;
				}
			}
		}
	} else {
		if (YYGETCONDITION() < 9) {
			if (YYGETCONDITION() < 7) {
				goto yyc_ST_VAR_OFFSET;
			} else {
				if (YYGETCONDITION() < 8) {
					goto yyc_INITIAL;
				} else {
					goto yyc_ST_ONE_LINE_COMMENT;
				}
			}
		} else {
			if (YYGETCONDITION() < 11) {
				if (YYGETCONDITION() < 10) {
					goto yyc_ST_COMMENT;
				} else {
					goto yyc_ST_DOC_COMMENT;
				}
			} else {
				if (YYGETCONDITION() < 12) {
					goto yyc_ST_END_HEREDOC;
				} else {
					goto yyc_ST_NOWDOC;
				}
			}
		}
	}
/* *********************************** */
yyc_INITIAL:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128,   0,   0, 128,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
		};

		YYDEBUG(0, *YYCURSOR);
		YYFILL(8);
		yych = *YYCURSOR;
		if (yych <= 0x00) goto yy2;
		if (yych == '<') goto yy4;
		goto yy6;
yy2:
		YYDEBUG(2, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(3, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2104 "Zend/zend_language_scanner.l"
		{ return 0; }
#line 944 "Zend/zend_language_scanner.c"
yy4:
		YYDEBUG(4, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '?') {
			if (yych == '%') goto yy9;
			if (yych >= '?') goto yy7;
		} else {
			if (yych <= 'S') {
				if (yych >= 'S') goto yy11;
			} else {
				if (yych == 's') goto yy11;
			}
		}
yy5:
		YYDEBUG(5, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1611 "Zend/zend_language_scanner.l"
		{

inline_char_handler:

	while (1) {
		YYCTYPE *ptr = memchr(YYCURSOR, '<', YYLIMIT - YYCURSOR);

		if (ptr == NULL) {
			YYCURSOR = YYLIMIT;
			yyleng   = YYCURSOR - SCNG(yy_text);
			break;

		} else {
			YYCURSOR = ptr + 1;

			/* stop if it may be an opening tag (<?, <%, <script>). this condition is not optimal though */
			if (YYCURSOR < YYLIMIT && (*YYCURSOR == '?' || *YYCURSOR == '%' || *YYCURSOR == 's')) {
				--YYCURSOR;
				yyleng = YYCURSOR - SCNG(yy_text);
				break;
			}
		}
	}

#ifdef ZEND_MULTIBYTE
	if (SCNG(output_filter)) {
		int readsize;
		size_t sz = 0;
		readsize = SCNG(output_filter)((unsigned char **)&(zendlval->value.str.val), &sz, (unsigned char *)yytext, (size_t)yyleng TSRMLS_CC);
		zendlval->value.str.len = sz;
		if (readsize < yyleng) {
			yyless(readsize);
		}
	} else {
	  zendlval->value.str.val = (char *) estrndup(yytext, yyleng);
	  zendlval->value.str.len = yyleng;
	}
#else /* !ZEND_MULTIBYTE */
	zendlval->value.str.val = (char *) estrndup(yytext, yyleng);
 	zendlval->value.str.len = yyleng;
#endif
	zendlval->type = IS_STRING;
	HANDLE_NEWLINES(yytext, yyleng);
	return T_INLINE_HTML;
}
#line 1008 "Zend/zend_language_scanner.c"
yy6:
		YYDEBUG(6, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy5;
yy7:
		YYDEBUG(7, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych == '=') goto yy47;
		} else {
			if (yych <= 'P') goto yy49;
			if (yych == 'p') goto yy49;
		}
yy8:
		YYDEBUG(8, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1599 "Zend/zend_language_scanner.l"
		{
	if (CG(short_tags)) {
		zendlval->value.str.val = yytext; /* no copying - intentional */
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		BEGIN(ST_IN_SCRIPTING);
		return T_OPEN_TAG;
	} else {
		goto inline_char_handler;
	}
}
#line 1038 "Zend/zend_language_scanner.c"
yy9:
		YYDEBUG(9, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy45;
		YYDEBUG(10, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1576 "Zend/zend_language_scanner.l"
		{
	if (CG(asp_tags)) {
		zendlval->value.str.val = yytext; /* no copying - intentional */
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		BEGIN(ST_IN_SCRIPTING);
		return T_OPEN_TAG;
	} else {
		goto inline_char_handler;
	}
}
#line 1057 "Zend/zend_language_scanner.c"
yy11:
		YYDEBUG(11, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy13;
		if (yych == 'c') goto yy13;
yy12:
		YYDEBUG(12, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 0) {
			goto yy5;
		} else {
			goto yy8;
		}
yy13:
		YYDEBUG(13, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy14;
		if (yych != 'r') goto yy12;
yy14:
		YYDEBUG(14, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy15;
		if (yych != 'i') goto yy12;
yy15:
		YYDEBUG(15, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy16;
		if (yych != 'p') goto yy12;
yy16:
		YYDEBUG(16, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy17;
		if (yych != 't') goto yy12;
yy17:
		YYDEBUG(17, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy12;
		if (yych == 'l') goto yy12;
		goto yy19;
yy18:
		YYDEBUG(18, *YYCURSOR);
		++YYCURSOR;
		YYFILL(8);
		yych = *YYCURSOR;
yy19:
		YYDEBUG(19, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy18;
		}
		if (yych == 'L') goto yy20;
		if (yych != 'l') goto yy12;
yy20:
		YYDEBUG(20, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy21;
		if (yych != 'a') goto yy12;
yy21:
		YYDEBUG(21, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy22;
		if (yych != 'n') goto yy12;
yy22:
		YYDEBUG(22, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy23;
		if (yych != 'g') goto yy12;
yy23:
		YYDEBUG(23, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy24;
		if (yych != 'u') goto yy12;
yy24:
		YYDEBUG(24, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy25;
		if (yych != 'a') goto yy12;
yy25:
		YYDEBUG(25, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy26;
		if (yych != 'g') goto yy12;
yy26:
		YYDEBUG(26, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy27;
		if (yych != 'e') goto yy12;
yy27:
		YYDEBUG(27, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(28, *YYCURSOR);
		if (yych <= '\r') {
			if (yych <= 0x08) goto yy12;
			if (yych <= '\n') goto yy27;
			if (yych <= '\f') goto yy12;
			goto yy27;
		} else {
			if (yych <= ' ') {
				if (yych <= 0x1F) goto yy12;
				goto yy27;
			} else {
				if (yych != '=') goto yy12;
			}
		}
yy29:
		YYDEBUG(29, *YYCURSOR);
		++YYCURSOR;
		YYFILL(5);
		yych = *YYCURSOR;
		YYDEBUG(30, *YYCURSOR);
		if (yych <= '!') {
			if (yych <= '\f') {
				if (yych <= 0x08) goto yy12;
				if (yych <= '\n') goto yy29;
				goto yy12;
			} else {
				if (yych <= '\r') goto yy29;
				if (yych == ' ') goto yy29;
				goto yy12;
			}
		} else {
			if (yych <= 'O') {
				if (yych <= '"') goto yy32;
				if (yych == '\'') goto yy33;
				goto yy12;
			} else {
				if (yych <= 'P') goto yy31;
				if (yych != 'p') goto yy12;
			}
		}
yy31:
		YYDEBUG(31, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy44;
		if (yych == 'h') goto yy44;
		goto yy12;
yy32:
		YYDEBUG(32, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy41;
		if (yych == 'p') goto yy41;
		goto yy12;
yy33:
		YYDEBUG(33, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy34;
		if (yych != 'p') goto yy12;
yy34:
		YYDEBUG(34, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy35;
		if (yych != 'h') goto yy12;
yy35:
		YYDEBUG(35, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy36;
		if (yych != 'p') goto yy12;
yy36:
		YYDEBUG(36, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '\'') goto yy12;
yy37:
		YYDEBUG(37, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(38, *YYCURSOR);
		if (yych <= '\r') {
			if (yych <= 0x08) goto yy12;
			if (yych <= '\n') goto yy37;
			if (yych <= '\f') goto yy12;
			goto yy37;
		} else {
			if (yych <= ' ') {
				if (yych <= 0x1F) goto yy12;
				goto yy37;
			} else {
				if (yych != '>') goto yy12;
			}
		}
		YYDEBUG(39, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(40, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1540 "Zend/zend_language_scanner.l"
		{
	HANDLE_NEWLINES(yytext, yyleng);
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	BEGIN(ST_IN_SCRIPTING);
	return T_OPEN_TAG;
}
#line 1252 "Zend/zend_language_scanner.c"
yy41:
		YYDEBUG(41, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy42;
		if (yych != 'h') goto yy12;
yy42:
		YYDEBUG(42, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy43;
		if (yych != 'p') goto yy12;
yy43:
		YYDEBUG(43, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '"') goto yy37;
		goto yy12;
yy44:
		YYDEBUG(44, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy37;
		if (yych == 'p') goto yy37;
		goto yy12;
yy45:
		YYDEBUG(45, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(46, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1550 "Zend/zend_language_scanner.l"
		{
	if (CG(asp_tags)) {
		zendlval->value.str.val = yytext; /* no copying - intentional */
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		BEGIN(ST_IN_SCRIPTING);
		return T_OPEN_TAG_WITH_ECHO;
	} else {
		goto inline_char_handler;
	}
}
#line 1291 "Zend/zend_language_scanner.c"
yy47:
		YYDEBUG(47, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(48, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1563 "Zend/zend_language_scanner.l"
		{
	if (CG(short_tags)) {
		zendlval->value.str.val = yytext; /* no copying - intentional */
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		BEGIN(ST_IN_SCRIPTING);
		return T_OPEN_TAG_WITH_ECHO;
	} else {
		goto inline_char_handler;
	}
}
#line 1309 "Zend/zend_language_scanner.c"
yy49:
		YYDEBUG(49, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy50;
		if (yych != 'h') goto yy12;
yy50:
		YYDEBUG(50, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy51;
		if (yych != 'p') goto yy12;
yy51:
		YYDEBUG(51, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '\f') {
			if (yych <= 0x08) goto yy12;
			if (yych >= '\v') goto yy12;
		} else {
			if (yych <= '\r') goto yy54;
			if (yych != ' ') goto yy12;
		}
yy52:
		YYDEBUG(52, *YYCURSOR);
		++YYCURSOR;
yy53:
		YYDEBUG(53, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1589 "Zend/zend_language_scanner.l"
		{
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	HANDLE_NEWLINE(yytext[yyleng-1]);
	BEGIN(ST_IN_SCRIPTING);
	return T_OPEN_TAG;
}
#line 1345 "Zend/zend_language_scanner.c"
yy54:
		YYDEBUG(54, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '\n') goto yy52;
		goto yy53;
	}
/* *********************************** */
yyc_ST_BACKQUOTE:
	{
		static const unsigned char yybm[] = {
			  0,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  32,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144,  16,  16,  16,  16,  16,  16, 
			 16, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144,  16,   0,  16,  16, 144, 
			  0, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144,  64,  16,  16,  16, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
		};
		YYDEBUG(55, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy63;
		}
		if (yych <= 0x00) goto yy57;
		if (yych <= '[') goto yy59;
		if (yych <= '\\') goto yy66;
		if (yych <= 'z') goto yy67;
		goto yy61;
yy57:
		YYDEBUG(57, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(58, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2104 "Zend/zend_language_scanner.l"
		{ return 0; }
#line 1407 "Zend/zend_language_scanner.c"
yy59:
		YYDEBUG(59, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy72;
		}
		if (yych <= '^') {
			if (yych <= 'Z') {
				if (yych <= 0x00) goto yy60;
				if (yych <= '@') goto yy63;
				goto yy78;
			} else {
				if (yych == '\\') goto yy71;
				goto yy63;
			}
		} else {
			if (yych <= 'z') {
				if (yych == '`') goto yy75;
				goto yy78;
			} else {
				if (yych <= '{') goto yy81;
				if (yych <= '~') goto yy63;
				goto yy78;
			}
		}
yy60:
		YYDEBUG(60, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 1) {
			if (yyaccept <= 0) {
				goto yy62;
			} else {
				goto yy65;
			}
		} else {
			if (yyaccept <= 2) {
				goto yy74;
			} else {
				goto yy80;
			}
		}
yy61:
		YYDEBUG(61, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy76;
		}
		if (yych <= '$') {
			if (yych <= 0x00) goto yy62;
			if (yych <= '#') goto yy64;
		} else {
			if (yych == '`') goto yy75;
			goto yy64;
		}
yy62:
		YYDEBUG(62, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1996 "Zend/zend_language_scanner.l"
		{
	zendlval->value.lval = (long) '{';
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	return T_CURLY_OPEN;
}
#line 1472 "Zend/zend_language_scanner.c"
yy63:
		YYDEBUG(63, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy64:
		YYDEBUG(64, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy63;
		}
		if (yych <= 0x00) goto yy65;
		if (yych <= '[') goto yy70;
		if (yych <= '\\') goto yy66;
		if (yych >= '{') goto yy69;
yy65:
		YYDEBUG(65, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2021 "Zend/zend_language_scanner.l"
		{
	zend_scan_escape_string(zendlval, yytext, yyleng, '`' TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 1496 "Zend/zend_language_scanner.c"
yy66:
		YYDEBUG(66, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= 0x00) goto yy60;
		goto yy63;
yy67:
		YYDEBUG(67, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(68, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2099 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_IN_SCRIPTING);
	return '`';
}
#line 1514 "Zend/zend_language_scanner.c"
yy69:
		YYDEBUG(69, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy63;
		}
		if (yych <= '[') goto yy60;
		if (yych <= '\\') goto yy66;
		if (yych <= 'z') goto yy75;
		goto yy76;
yy70:
		YYDEBUG(70, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy72;
		}
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= 0x00) goto yy60;
				goto yy63;
			} else {
				if (yych <= 'Z') goto yy60;
				if (yych <= '[') goto yy63;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '^') goto yy63;
				if (yych <= '_') goto yy60;
				goto yy75;
			} else {
				if (yych <= '{') goto yy60;
				if (yych <= '~') goto yy63;
				goto yy60;
			}
		}
yy71:
		YYDEBUG(71, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= 0x00) goto yy60;
		goto yy63;
yy72:
		YYDEBUG(72, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(73, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy72;
		}
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych >= 0x01) goto yy63;
			} else {
				if (yych <= 'Z') goto yy74;
				if (yych <= '[') goto yy63;
				goto yy71;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '^') goto yy63;
				if (yych >= '`') goto yy75;
			} else {
				if (yych <= '{') goto yy74;
				if (yych <= '~') goto yy63;
			}
		}
yy74:
		YYDEBUG(74, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2026 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	zend_scan_escape_string(zendlval, yytext, yyleng, '`' TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 1597 "Zend/zend_language_scanner.c"
yy75:
		YYDEBUG(75, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy74;
yy76:
		YYDEBUG(76, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(77, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy63;
		}
		if (yych <= '[') goto yy74;
		if (yych <= '\\') goto yy66;
		if (yych <= 'z') goto yy75;
		goto yy76;
yy78:
		YYDEBUG(78, *YYCURSOR);
		yyaccept = 3;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(79, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy78;
		}
		if (yych == '-') goto yy83;
		if (yych == '[') goto yy84;
yy80:
		YYDEBUG(80, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1679 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 1637 "Zend/zend_language_scanner.c"
yy81:
		YYDEBUG(81, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(82, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1333 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME TSRMLS_CC);
	return T_DOLLAR_OPEN_CURLY_BRACES;
}
#line 1648 "Zend/zend_language_scanner.c"
yy83:
		YYDEBUG(83, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy86;
		goto yy60;
yy84:
		YYDEBUG(84, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(85, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1671 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 1667 "Zend/zend_language_scanner.c"
yy86:
		YYDEBUG(86, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy60;
			if (yych <= 'Z') goto yy87;
			if (yych <= '^') goto yy60;
		} else {
			if (yych <= '`') goto yy60;
			if (yych <= 'z') goto yy87;
			if (yych <= '~') goto yy60;
		}
yy87:
		YYDEBUG(87, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(88, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1661 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 1693 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_COMMENT:
	{
		static const unsigned char yybm[] = {
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(89, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 128) {
			goto yy93;
		}
		if (yych >= 0x01) goto yy96;
		YYDEBUG(91, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(92, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1765 "Zend/zend_language_scanner.l"
		{
	zend_error(E_COMPILE_WARNING, "Unterminated comment starting line %d", CG(zend_lineno));
	return 0;
}
#line 1748 "Zend/zend_language_scanner.c"
yy93:
		YYDEBUG(93, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(94, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy93;
		}
		YYDEBUG(95, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1776 "Zend/zend_language_scanner.l"
		{
	yymore();
}
#line 1764 "Zend/zend_language_scanner.c"
yy96:
		YYDEBUG(96, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '/') goto yy98;
		YYDEBUG(97, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1794 "Zend/zend_language_scanner.l"
		{
	yymore();
}
#line 1775 "Zend/zend_language_scanner.c"
yy98:
		YYDEBUG(98, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(99, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1788 "Zend/zend_language_scanner.l"
		{
	HANDLE_NEWLINES(yytext, yyleng);
	BEGIN(ST_IN_SCRIPTING);
	return T_COMMENT;
}
#line 1787 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_DOC_COMMENT:
	{
		static const unsigned char yybm[] = {
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(100, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 128) {
			goto yy104;
		}
		if (yych >= 0x01) goto yy107;
		YYDEBUG(102, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(103, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1765 "Zend/zend_language_scanner.l"
		{
	zend_error(E_COMPILE_WARNING, "Unterminated comment starting line %d", CG(zend_lineno));
	return 0;
}
#line 1842 "Zend/zend_language_scanner.c"
yy104:
		YYDEBUG(104, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(105, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy104;
		}
		YYDEBUG(106, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1776 "Zend/zend_language_scanner.l"
		{
	yymore();
}
#line 1858 "Zend/zend_language_scanner.c"
yy107:
		YYDEBUG(107, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '/') goto yy109;
		YYDEBUG(108, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1794 "Zend/zend_language_scanner.l"
		{
	yymore();
}
#line 1869 "Zend/zend_language_scanner.c"
yy109:
		YYDEBUG(109, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(110, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1780 "Zend/zend_language_scanner.l"
		{
	CG(doc_comment) = estrndup(yytext, yyleng);
	CG(doc_comment_len) = yyleng;
	HANDLE_NEWLINES(yytext, yyleng);
	BEGIN(ST_IN_SCRIPTING);
	return T_DOC_COMMENT;
}
#line 1883 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_DOUBLE_QUOTES:
	{
		static const unsigned char yybm[] = {
			  0,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,   0,  16,  32,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144,  16,  16,  16,  16,  16,  16, 
			 16, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144,  16,   0,  16,  16, 144, 
			 16, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144,  64,  16,  16,  16, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
		};
		YYDEBUG(111, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy119;
		}
		if (yych <= 0x00) goto yy113;
		if (yych <= '#') goto yy123;
		if (yych <= '$') goto yy115;
		if (yych <= 'z') goto yy122;
		goto yy117;
yy113:
		YYDEBUG(113, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(114, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2104 "Zend/zend_language_scanner.l"
		{ return 0; }
#line 1940 "Zend/zend_language_scanner.c"
yy115:
		YYDEBUG(115, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy128;
		}
		if (yych <= '\\') {
			if (yych <= '"') {
				if (yych <= 0x00) goto yy116;
				if (yych <= '!') goto yy119;
				goto yy131;
			} else {
				if (yych <= '@') goto yy119;
				if (yych <= 'Z') goto yy134;
				if (yych <= '[') goto yy119;
				goto yy127;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy134;
				goto yy119;
			} else {
				if (yych <= 'z') goto yy134;
				if (yych <= '{') goto yy137;
				if (yych <= '~') goto yy119;
				goto yy134;
			}
		}
yy116:
		YYDEBUG(116, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 1) {
			if (yyaccept <= 0) {
				goto yy118;
			} else {
				goto yy121;
			}
		} else {
			if (yyaccept <= 2) {
				goto yy130;
			} else {
				goto yy136;
			}
		}
yy117:
		YYDEBUG(117, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy132;
		}
		if (yych <= '"') {
			if (yych <= 0x00) goto yy118;
			if (yych <= '!') goto yy120;
			goto yy131;
		} else {
			if (yych != '$') goto yy120;
		}
yy118:
		YYDEBUG(118, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1996 "Zend/zend_language_scanner.l"
		{
	zendlval->value.lval = (long) '{';
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	return T_CURLY_OPEN;
}
#line 2008 "Zend/zend_language_scanner.c"
yy119:
		YYDEBUG(119, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy120:
		YYDEBUG(120, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy119;
		}
		if (yych <= '#') goto yy121;
		if (yych <= '$') goto yy126;
		if (yych <= 'z') goto yy122;
		goto yy125;
yy121:
		YYDEBUG(121, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2003 "Zend/zend_language_scanner.l"
		{
	zend_scan_escape_string(zendlval, yytext, yyleng, '"' TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 2032 "Zend/zend_language_scanner.c"
yy122:
		YYDEBUG(122, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= 0x00) goto yy116;
		goto yy119;
yy123:
		YYDEBUG(123, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(124, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2093 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_IN_SCRIPTING);
	return '"';
}
#line 2050 "Zend/zend_language_scanner.c"
yy125:
		YYDEBUG(125, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy119;
		}
		if (yych <= 0x00) goto yy116;
		if (yych <= '#') goto yy131;
		if (yych <= '$') goto yy116;
		if (yych <= 'z') goto yy122;
		goto yy132;
yy126:
		YYDEBUG(126, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy128;
		}
		if (yych <= '[') {
			if (yych <= '"') {
				if (yych <= 0x00) goto yy116;
				if (yych <= '!') goto yy119;
				goto yy131;
			} else {
				if (yych <= '@') goto yy119;
				if (yych <= 'Z') goto yy116;
				goto yy119;
			}
		} else {
			if (yych <= '_') {
				if (yych <= '\\') goto yy127;
				if (yych <= '^') goto yy119;
				goto yy116;
			} else {
				if (yych <= '`') goto yy119;
				if (yych <= '{') goto yy116;
				if (yych <= '~') goto yy119;
				goto yy116;
			}
		}
yy127:
		YYDEBUG(127, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= 0x00) goto yy116;
		goto yy119;
yy128:
		YYDEBUG(128, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(129, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy128;
		}
		if (yych <= '[') {
			if (yych <= '"') {
				if (yych <= 0x00) goto yy130;
				if (yych <= '!') goto yy119;
				goto yy131;
			} else {
				if (yych <= '@') goto yy119;
				if (yych >= '[') goto yy119;
			}
		} else {
			if (yych <= '_') {
				if (yych <= '\\') goto yy127;
				if (yych <= '^') goto yy119;
			} else {
				if (yych <= '`') goto yy119;
				if (yych <= '{') goto yy130;
				if (yych <= '~') goto yy119;
			}
		}
yy130:
		YYDEBUG(130, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2014 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	zend_scan_escape_string(zendlval, yytext, yyleng, '"' TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 2139 "Zend/zend_language_scanner.c"
yy131:
		YYDEBUG(131, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy130;
yy132:
		YYDEBUG(132, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(133, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy119;
		}
		if (yych <= 0x00) goto yy130;
		if (yych <= '#') goto yy131;
		if (yych <= '$') goto yy130;
		if (yych <= 'z') goto yy122;
		goto yy132;
yy134:
		YYDEBUG(134, *YYCURSOR);
		yyaccept = 3;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(135, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy134;
		}
		if (yych == '-') goto yy139;
		if (yych == '[') goto yy140;
yy136:
		YYDEBUG(136, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1679 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 2180 "Zend/zend_language_scanner.c"
yy137:
		YYDEBUG(137, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(138, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1333 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME TSRMLS_CC);
	return T_DOLLAR_OPEN_CURLY_BRACES;
}
#line 2191 "Zend/zend_language_scanner.c"
yy139:
		YYDEBUG(139, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy142;
		goto yy116;
yy140:
		YYDEBUG(140, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(141, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1671 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 2210 "Zend/zend_language_scanner.c"
yy142:
		YYDEBUG(142, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy116;
			if (yych <= 'Z') goto yy143;
			if (yych <= '^') goto yy116;
		} else {
			if (yych <= '`') goto yy116;
			if (yych <= 'z') goto yy143;
			if (yych <= '~') goto yy116;
		}
yy143:
		YYDEBUG(143, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(144, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1661 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 2236 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_END_HEREDOC:
	YYDEBUG(145, *YYCURSOR);
	YYFILL(1);
	yych = *YYCURSOR;
	if (yych >= 0x01) goto yy149;
	YYDEBUG(147, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(148, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
#line 2104 "Zend/zend_language_scanner.l"
	{ return 0; }
#line 2250 "Zend/zend_language_scanner.c"
yy149:
	YYDEBUG(149, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(150, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
#line 1982 "Zend/zend_language_scanner.l"
	{
	YYCURSOR += CG(heredoc_len) - 1;
	yyleng = CG(heredoc_len);

	Z_STRVAL_P(zendlval) = CG(heredoc);
	Z_STRLEN_P(zendlval) = CG(heredoc_len);
	CG(heredoc) = NULL;
	CG(heredoc_len) = 0;
	BEGIN(ST_IN_SCRIPTING);
	return T_END_HEREDOC;
}
#line 2268 "Zend/zend_language_scanner.c"
/* *********************************** */
yyc_ST_HEREDOC:
	{
		static const unsigned char yybm[] = {
			  0,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,  16,   4,   4,  32,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,  64,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			 12,  12,  12,  12,  12,  12,  12,  12, 
			 12,  12,   4,   4,   4,   4,   4,   4, 
			  4,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   4,   0,   4,   4,   8, 
			  4,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8, 128,   4,   4,   4,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
		};
		YYDEBUG(151, *YYCURSOR);
		YYFILL(2);
		yych = *(YYMARKER = YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy160;
		}
		if (yych <= '@') {
			if (yych <= 0x00) goto yy154;
			if (yych <= '\f') goto yy165;
			if (yych <= '\r') goto yy167;
			goto yy156;
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy162;
				goto yy164;
			} else {
				if (yych == '{') goto yy158;
				goto yy162;
			}
		}
yy153:
		YYDEBUG(153, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2040 "Zend/zend_language_scanner.l"
		{
	zend_scan_escape_string(zendlval, yytext, yyleng, 0 TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 2334 "Zend/zend_language_scanner.c"
yy154:
		YYDEBUG(154, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(155, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2104 "Zend/zend_language_scanner.l"
		{ return 0; }
#line 2342 "Zend/zend_language_scanner.c"
yy156:
		YYDEBUG(156, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '\\') {
			if (yych <= '$') {
				if (yych <= 0x00) goto yy157;
				if (yych <= '#') goto yy161;
				goto yy201;
			} else {
				if (yych <= '@') goto yy161;
				if (yych <= 'Z') goto yy205;
				if (yych <= '[') goto yy161;
				goto yy194;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy205;
				goto yy161;
			} else {
				if (yych <= 'z') goto yy205;
				if (yych <= '{') goto yy208;
				if (yych <= '~') goto yy161;
				goto yy205;
			}
		}
yy157:
		YYDEBUG(157, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 1) {
			if (yyaccept <= 0) {
				goto yy153;
			} else {
				goto yy159;
			}
		} else {
			if (yyaccept <= 2) {
				goto yy177;
			} else {
				goto yy207;
			}
		}
yy158:
		YYDEBUG(158, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= '$') {
			if (yych <= '\f') {
				if (yych >= 0x01) goto yy160;
			} else {
				if (yych <= '\r') goto yy167;
				if (yych <= '#') goto yy160;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy160;
				goto yy164;
			} else {
				if (yych == '{') goto yy203;
				goto yy160;
			}
		}
yy159:
		YYDEBUG(159, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1996 "Zend/zend_language_scanner.l"
		{
	zendlval->value.lval = (long) '{';
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	return T_CURLY_OPEN;
}
#line 2416 "Zend/zend_language_scanner.c"
yy160:
		YYDEBUG(160, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy161:
		YYDEBUG(161, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy160;
		}
		if (yych <= '@') {
			if (yych <= 0x00) goto yy153;
			if (yych <= '\f') goto yy165;
			if (yych <= '\r') goto yy167;
			goto yy200;
		} else {
			if (yych <= '\\') {
				if (yych >= '\\') goto yy164;
			} else {
				if (yych == '{') goto yy199;
			}
		}
yy162:
		YYDEBUG(162, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(163, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= '@') {
			if (yych <= '$') {
				if (yych <= '\f') {
					if (yych <= 0x00) goto yy153;
					goto yy160;
				} else {
					if (yych <= '\r') goto yy167;
					if (yych <= '#') goto yy160;
					goto yy193;
				}
			} else {
				if (yych <= '9') {
					if (yych <= '/') goto yy160;
					goto yy162;
				} else {
					if (yych == ';') goto yy191;
					goto yy160;
				}
			}
		} else {
			if (yych <= '_') {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy162;
					goto yy160;
				} else {
					if (yych <= '\\') goto yy164;
					if (yych <= '^') goto yy160;
					goto yy162;
				}
			} else {
				if (yych <= 'z') {
					if (yych <= '`') goto yy160;
					goto yy162;
				} else {
					if (yych <= '{') goto yy192;
					if (yych <= '~') goto yy160;
					goto yy162;
				}
			}
		}
yy164:
		YYDEBUG(164, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= 0x00) goto yy157;
		if (yych == '\r') goto yy167;
		goto yy160;
yy165:
		YYDEBUG(165, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(166, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy160;
		}
		if (yych <= '@') {
			if (yych <= 0x00) goto yy153;
			if (yych <= '\f') goto yy165;
			if (yych >= 0x0E) goto yy172;
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy169;
				goto yy173;
			} else {
				if (yych == '{') goto yy171;
				goto yy169;
			}
		}
yy167:
		YYDEBUG(167, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(168, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy160;
		}
		if (yych <= '@') {
			if (yych <= 0x00) goto yy153;
			if (yych <= '\f') goto yy165;
			if (yych <= '\r') goto yy167;
			goto yy172;
		} else {
			if (yych <= '\\') {
				if (yych >= '\\') goto yy173;
			} else {
				if (yych == '{') goto yy171;
			}
		}
yy169:
		YYDEBUG(169, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(170, *YYCURSOR);
		if (yych <= ';') {
			if (yych <= '\r') {
				if (yych <= '\t') {
					if (yych <= 0x00) goto yy153;
					goto yy160;
				} else {
					if (yych <= '\n') goto yy184;
					if (yych <= '\f') goto yy160;
					goto yy184;
				}
			} else {
				if (yych <= '/') {
					if (yych == '$') goto yy183;
					goto yy160;
				} else {
					if (yych <= '9') goto yy169;
					if (yych <= ':') goto yy160;
					goto yy180;
				}
			}
		} else {
			if (yych <= '^') {
				if (yych <= 'Z') {
					if (yych <= '@') goto yy160;
					goto yy169;
				} else {
					if (yych == '\\') goto yy181;
					goto yy160;
				}
			} else {
				if (yych <= 'z') {
					if (yych == '`') goto yy160;
					goto yy169;
				} else {
					if (yych <= '{') goto yy182;
					if (yych <= '~') goto yy160;
					goto yy169;
				}
			}
		}
yy171:
		YYDEBUG(171, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= '$') {
			if (yych <= '\f') {
				if (yych <= 0x00) goto yy157;
				goto yy160;
			} else {
				if (yych <= '\r') goto yy167;
				if (yych <= '#') goto yy160;
				goto yy157;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy160;
				goto yy173;
			} else {
				if (yych == '{') goto yy178;
				goto yy160;
			}
		}
yy172:
		YYDEBUG(172, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 4) {
			goto yy160;
		}
		if (yych <= '\r') {
			if (yych <= 0x00) goto yy157;
			if (yych <= '\f') goto yy165;
			goto yy167;
		} else {
			if (yych <= '@') goto yy175;
			if (yych == '\\') goto yy174;
			goto yy157;
		}
yy173:
		YYDEBUG(173, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= 0x00) goto yy157;
		if (yych == '\r') goto yy167;
		goto yy160;
yy174:
		YYDEBUG(174, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= 0x00) goto yy157;
		if (yych == '\r') goto yy167;
		goto yy160;
yy175:
		YYDEBUG(175, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(176, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy160;
		}
		if (yych <= '\r') {
			if (yych <= 0x00) goto yy177;
			if (yych <= '\f') goto yy165;
			goto yy167;
		} else {
			if (yych <= '@') goto yy175;
			if (yych == '\\') goto yy174;
		}
yy177:
		YYDEBUG(177, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2045 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	zend_scan_escape_string(zendlval, yytext, yyleng, 0 TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 2685 "Zend/zend_language_scanner.c"
yy178:
		YYDEBUG(178, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(179, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= '$') {
			if (yych <= '\f') {
				if (yych <= 0x00) goto yy177;
				goto yy160;
			} else {
				if (yych <= '\r') goto yy167;
				if (yych <= '#') goto yy160;
				goto yy177;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy160;
				goto yy173;
			} else {
				if (yych == '{') goto yy178;
				goto yy160;
			}
		}
yy180:
		YYDEBUG(180, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '#') {
			if (yych <= '\n') {
				if (yych <= 0x00) goto yy153;
				if (yych <= '\t') goto yy160;
				goto yy184;
			} else {
				if (yych == '\r') goto yy184;
				goto yy160;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '$') goto yy183;
				if (yych <= '[') goto yy160;
			} else {
				if (yych == '{') goto yy182;
				goto yy160;
			}
		}
yy181:
		YYDEBUG(181, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= 0x00) goto yy157;
		if (yych == '\r') goto yy167;
		goto yy160;
yy182:
		YYDEBUG(182, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= '$') {
			if (yych <= '\f') {
				if (yych <= 0x00) goto yy157;
				goto yy160;
			} else {
				if (yych <= '\r') goto yy167;
				if (yych <= '#') goto yy160;
				goto yy157;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy160;
				goto yy181;
			} else {
				if (yych == '{') goto yy189;
				goto yy160;
			}
		}
yy183:
		YYDEBUG(183, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 4) {
			goto yy160;
		}
		if (yych <= '\r') {
			if (yych <= 0x00) goto yy157;
			if (yych <= '\f') goto yy165;
			goto yy167;
		} else {
			if (yych <= '@') goto yy186;
			if (yych == '\\') goto yy188;
			goto yy157;
		}
yy184:
		YYDEBUG(184, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(185, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1945 "Zend/zend_language_scanner.l"
		{
	char *end = yytext + yyleng - 1;

	if (end[-1] == ';') {
		end--;
		yyleng--;
	}

	if (yyleng > CG(heredoc_len) && !memcmp(end - CG(heredoc_len), CG(heredoc), CG(heredoc_len))) {
		int len = yyleng - CG(heredoc_len) - 2; /* 2 for newline before and after label */

		/* May have matched fooLABEL; make sure there's a newline before it */
		if (yytext[len] != '\n') {
			if (yytext[len] != '\r') {
				yyless(yyleng - 1);
				yymore();
			}
		} else if (len > 0 && yytext[len - 1] == '\r') {
			len--; /* Windows newline */
		}

		/* Go back before label, to match in ST_END_HEREDOC state. yytext will include
		 * newline before label, for zend_highlight/strip, tokenizer, etc. */
		yyless(yyleng - CG(heredoc_len) - 1); /* 1 for newline after label */

		CG(increment_lineno) = 1; /* For newline before label */
		BEGIN(ST_END_HEREDOC);
		zend_scan_escape_string(zendlval, yytext, len, 0 TSRMLS_CC);
		return T_ENCAPSED_AND_WHITESPACE;
	} else {
		/* Go back to end of label, so the next match works correctly in case of
		 * a variable or another label at the beginning of the next line */
		yyless(yyleng - 1);
		yymore();
	}
}
#line 2834 "Zend/zend_language_scanner.c"
yy186:
		YYDEBUG(186, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(187, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy160;
		}
		if (yych <= '\r') {
			if (yych <= 0x00) goto yy177;
			if (yych <= '\f') goto yy165;
			goto yy167;
		} else {
			if (yych <= '@') goto yy186;
			if (yych != '\\') goto yy177;
		}
yy188:
		YYDEBUG(188, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= 0x00) goto yy157;
		if (yych == '\r') goto yy167;
		goto yy160;
yy189:
		YYDEBUG(189, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(190, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= '$') {
			if (yych <= '\f') {
				if (yych <= 0x00) goto yy177;
				goto yy160;
			} else {
				if (yych <= '\r') goto yy167;
				if (yych <= '#') goto yy160;
				goto yy177;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy160;
				goto yy181;
			} else {
				if (yych == '{') goto yy189;
				goto yy160;
			}
		}
yy191:
		YYDEBUG(191, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 4) {
			goto yy160;
		}
		if (yych <= '@') {
			if (yych <= 0x00) goto yy153;
			if (yych <= '\f') goto yy165;
			if (yych <= '\r') goto yy167;
			goto yy193;
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy162;
				goto yy164;
			} else {
				if (yych != '{') goto yy162;
			}
		}
yy192:
		YYDEBUG(192, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= '$') {
			if (yych <= '\f') {
				if (yych <= 0x00) goto yy157;
				goto yy160;
			} else {
				if (yych <= '\r') goto yy167;
				if (yych <= '#') goto yy160;
				goto yy157;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy160;
				goto yy164;
			} else {
				if (yych == '{') goto yy197;
				goto yy160;
			}
		}
yy193:
		YYDEBUG(193, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 4) {
			goto yy160;
		}
		if (yych <= '\r') {
			if (yych <= 0x00) goto yy157;
			if (yych <= '\f') goto yy165;
			goto yy167;
		} else {
			if (yych <= '@') goto yy195;
			if (yych != '\\') goto yy157;
		}
yy194:
		YYDEBUG(194, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= 0x00) goto yy157;
		if (yych == '\r') goto yy167;
		goto yy160;
yy195:
		YYDEBUG(195, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(196, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy160;
		}
		if (yych <= '\r') {
			if (yych <= 0x00) goto yy177;
			if (yych <= '\f') goto yy165;
			goto yy167;
		} else {
			if (yych <= '@') goto yy195;
			if (yych == '\\') goto yy194;
			goto yy177;
		}
yy197:
		YYDEBUG(197, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(198, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= '$') {
			if (yych <= '\f') {
				if (yych <= 0x00) goto yy177;
				goto yy160;
			} else {
				if (yych <= '\r') goto yy167;
				if (yych <= '#') goto yy160;
				goto yy177;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy160;
				goto yy164;
			} else {
				if (yych == '{') goto yy197;
				goto yy160;
			}
		}
yy199:
		YYDEBUG(199, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= '$') {
			if (yych <= '\f') {
				if (yych <= 0x00) goto yy157;
				goto yy160;
			} else {
				if (yych <= '\r') goto yy167;
				if (yych <= '#') goto yy160;
				goto yy157;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy160;
				goto yy164;
			} else {
				if (yych == '{') goto yy203;
				goto yy160;
			}
		}
yy200:
		YYDEBUG(200, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 4) {
			goto yy160;
		}
		if (yych <= '\r') {
			if (yych <= 0x00) goto yy157;
			if (yych <= '\f') goto yy165;
			goto yy167;
		} else {
			if (yych <= '@') goto yy201;
			if (yych == '\\') goto yy194;
			goto yy157;
		}
yy201:
		YYDEBUG(201, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(202, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy160;
		}
		if (yych <= '\r') {
			if (yych <= 0x00) goto yy177;
			if (yych <= '\f') goto yy165;
			goto yy167;
		} else {
			if (yych <= '@') goto yy201;
			if (yych == '\\') goto yy194;
			goto yy177;
		}
yy203:
		YYDEBUG(203, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(204, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy165;
		}
		if (yych <= '$') {
			if (yych <= '\f') {
				if (yych <= 0x00) goto yy177;
				goto yy160;
			} else {
				if (yych <= '\r') goto yy167;
				if (yych <= '#') goto yy160;
				goto yy177;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy160;
				goto yy164;
			} else {
				if (yych == '{') goto yy203;
				goto yy160;
			}
		}
yy205:
		YYDEBUG(205, *YYCURSOR);
		yyaccept = 3;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(206, *YYCURSOR);
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych == '-') goto yy210;
			} else {
				if (yych <= '9') goto yy205;
				if (yych >= 'A') goto yy205;
			}
		} else {
			if (yych <= '_') {
				if (yych <= '[') goto yy211;
				if (yych >= '_') goto yy205;
			} else {
				if (yych <= '`') goto yy207;
				if (yych <= 'z') goto yy205;
				if (yych >= 0x7F) goto yy205;
			}
		}
yy207:
		YYDEBUG(207, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1679 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 3137 "Zend/zend_language_scanner.c"
yy208:
		YYDEBUG(208, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(209, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1333 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME TSRMLS_CC);
	return T_DOLLAR_OPEN_CURLY_BRACES;
}
#line 3148 "Zend/zend_language_scanner.c"
yy210:
		YYDEBUG(210, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy213;
		goto yy157;
yy211:
		YYDEBUG(211, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(212, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1671 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 3167 "Zend/zend_language_scanner.c"
yy213:
		YYDEBUG(213, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy157;
			if (yych <= 'Z') goto yy214;
			if (yych <= '^') goto yy157;
		} else {
			if (yych <= '`') goto yy157;
			if (yych <= 'z') goto yy214;
			if (yych <= '~') goto yy157;
		}
yy214:
		YYDEBUG(214, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(215, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1661 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 3193 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_IN_SCRIPTING:
	{
		static const unsigned char yybm[] = {
			/* table 1 .. 8: 0 */
			  0,   2,   2,   2,   2,   2,   2,   2, 
			  2, 194,  66,   2,   2,  66,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			194,   2,   0,   2,   4,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			 58,  58,  58,  58,  58,  58,  58,  58, 
			 58,  58,   2,   2,   2,   2,   2,   2, 
			  2,  42,  42,  42,  42,  42,  42,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,   2,   0,   2,   2,  10, 
			  2,  42,  42,  42,  42,  42,  42,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,   1,   2,   2,   2,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			/* table 9 .. 9: 256 */
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128,   0, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(216, *YYCURSOR);
		YYFILL(16);
		yych = *YYCURSOR;
		YYDEBUG(-1, yych);
		switch (yych) {
		case 0x00:	goto yy218;
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x1F:	goto yy280;
		case '\t':
		case '\n':
		case '\r':
		case ' ':	goto yy236;
		case '!':	goto yy249;
		case '"':	goto yy274;
		case '#':	goto yy272;
		case '$':	goto yy261;
		case '%':	goto yy255;
		case '&':	goto yy256;
		case '\'':	goto yy276;
		case '(':	goto yy243;
		case ')':
		case ',':
		case ';':
		case '@':
		case '[':
		case ']':
		case '~':	goto yy262;
		case '*':	goto yy252;
		case '+':	goto yy248;
		case '-':	goto yy234;
		case '.':	goto yy254;
		case '/':	goto yy253;
		case '0':	goto yy268;
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':	goto yy270;
		case ':':	goto yy238;
		case '<':	goto yy250;
		case '=':	goto yy246;
		case '>':	goto yy251;
		case '?':	goto yy263;
		case 'A':
		case 'a':	goto yy229;
		case 'B':
		case 'b':	goto yy231;
		case 'C':
		case 'c':	goto yy224;
		case 'D':
		case 'd':	goto yy222;
		case 'E':
		case 'e':	goto yy220;
		case 'F':
		case 'f':	goto yy223;
		case 'G':
		case 'g':	goto yy232;
		case 'I':
		case 'i':	goto yy227;
		case 'L':
		case 'l':	goto yy247;
		case 'N':
		case 'n':	goto yy241;
		case 'O':
		case 'o':	goto yy259;
		case 'P':
		case 'p':	goto yy233;
		case 'R':
		case 'r':	goto yy225;
		case 'S':
		case 's':	goto yy230;
		case 'T':
		case 't':	goto yy226;
		case 'U':
		case 'u':	goto yy244;
		case 'V':
		case 'v':	goto yy242;
		case 'W':
		case 'w':	goto yy228;
		case 'X':
		case 'x':	goto yy260;
		case '\\':	goto yy239;
		case '^':	goto yy258;
		case '_':	goto yy245;
		case '`':	goto yy278;
		case '{':	goto yy264;
		case '|':	goto yy257;
		case '}':	goto yy266;
		default:	goto yy271;
		}
yy218:
		YYDEBUG(218, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(219, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2104 "Zend/zend_language_scanner.l"
		{ return 0; }
#line 3393 "Zend/zend_language_scanner.c"
yy220:
		YYDEBUG(220, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(-1, yych);
		switch ((yych = *YYCURSOR)) {
		case 'C':
		case 'c':	goto yy812;
		case 'L':
		case 'l':	goto yy813;
		case 'M':
		case 'm':	goto yy814;
		case 'N':
		case 'n':	goto yy815;
		case 'V':
		case 'v':	goto yy816;
		case 'X':
		case 'x':	goto yy817;
		default:	goto yy298;
		}
yy221:
		YYDEBUG(221, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1703 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, yytext, yyleng);
	zendlval->type = IS_STRING;
	return T_STRING;
}
#line 3422 "Zend/zend_language_scanner.c"
yy222:
		YYDEBUG(222, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych <= 'H') {
				if (yych == 'E') goto yy794;
				goto yy298;
			} else {
				if (yych <= 'I') goto yy795;
				if (yych <= 'N') goto yy298;
				goto yy796;
			}
		} else {
			if (yych <= 'h') {
				if (yych == 'e') goto yy794;
				goto yy298;
			} else {
				if (yych <= 'i') goto yy795;
				if (yych == 'o') goto yy796;
				goto yy298;
			}
		}
yy223:
		YYDEBUG(223, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'U') {
			if (yych <= 'N') {
				if (yych == 'I') goto yy773;
				goto yy298;
			} else {
				if (yych <= 'O') goto yy774;
				if (yych <= 'T') goto yy298;
				goto yy775;
			}
		} else {
			if (yych <= 'n') {
				if (yych == 'i') goto yy773;
				goto yy298;
			} else {
				if (yych <= 'o') goto yy774;
				if (yych == 'u') goto yy775;
				goto yy298;
			}
		}
yy224:
		YYDEBUG(224, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych <= 'K') {
				if (yych == 'A') goto yy745;
				goto yy298;
			} else {
				if (yych <= 'L') goto yy746;
				if (yych <= 'N') goto yy298;
				goto yy747;
			}
		} else {
			if (yych <= 'k') {
				if (yych == 'a') goto yy745;
				goto yy298;
			} else {
				if (yych <= 'l') goto yy746;
				if (yych == 'o') goto yy747;
				goto yy298;
			}
		}
yy225:
		YYDEBUG(225, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy727;
		if (yych == 'e') goto yy727;
		goto yy298;
yy226:
		YYDEBUG(226, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'R') {
			if (yych == 'H') goto yy719;
			if (yych <= 'Q') goto yy298;
			goto yy720;
		} else {
			if (yych <= 'h') {
				if (yych <= 'g') goto yy298;
				goto yy719;
			} else {
				if (yych == 'r') goto yy720;
				goto yy298;
			}
		}
yy227:
		YYDEBUG(227, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'S') {
			if (yych <= 'L') {
				if (yych == 'F') goto yy672;
				goto yy298;
			} else {
				if (yych <= 'M') goto yy674;
				if (yych <= 'N') goto yy675;
				if (yych <= 'R') goto yy298;
				goto yy676;
			}
		} else {
			if (yych <= 'm') {
				if (yych == 'f') goto yy672;
				if (yych <= 'l') goto yy298;
				goto yy674;
			} else {
				if (yych <= 'n') goto yy675;
				if (yych == 's') goto yy676;
				goto yy298;
			}
		}
yy228:
		YYDEBUG(228, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy667;
		if (yych == 'h') goto yy667;
		goto yy298;
yy229:
		YYDEBUG(229, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'S') {
			if (yych <= 'M') {
				if (yych == 'B') goto yy649;
				goto yy298;
			} else {
				if (yych <= 'N') goto yy650;
				if (yych <= 'Q') goto yy298;
				if (yych <= 'R') goto yy651;
				goto yy652;
			}
		} else {
			if (yych <= 'n') {
				if (yych == 'b') goto yy649;
				if (yych <= 'm') goto yy298;
				goto yy650;
			} else {
				if (yych <= 'q') goto yy298;
				if (yych <= 'r') goto yy651;
				if (yych <= 's') goto yy652;
				goto yy298;
			}
		}
yy230:
		YYDEBUG(230, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'W') {
			if (yych == 'T') goto yy637;
			if (yych <= 'V') goto yy298;
			goto yy638;
		} else {
			if (yych <= 't') {
				if (yych <= 's') goto yy298;
				goto yy637;
			} else {
				if (yych == 'w') goto yy638;
				goto yy298;
			}
		}
yy231:
		YYDEBUG(231, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'Q') {
			if (yych <= '/') {
				if (yych <= '"') {
					if (yych <= '!') goto yy221;
					goto yy630;
				} else {
					if (yych == '\'') goto yy281;
					goto yy221;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy297;
					goto yy221;
				} else {
					if (yych <= '<') goto yy629;
					if (yych <= '@') goto yy221;
					goto yy297;
				}
			}
		} else {
			if (yych <= '`') {
				if (yych <= 'Z') {
					if (yych <= 'R') goto yy631;
					goto yy297;
				} else {
					if (yych == '_') goto yy297;
					goto yy221;
				}
			} else {
				if (yych <= 'r') {
					if (yych <= 'q') goto yy297;
					goto yy631;
				} else {
					if (yych <= 'z') goto yy297;
					if (yych <= '~') goto yy221;
					goto yy297;
				}
			}
		}
yy232:
		YYDEBUG(232, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'L') goto yy619;
			if (yych <= 'N') goto yy298;
			goto yy620;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy298;
				goto yy619;
			} else {
				if (yych == 'o') goto yy620;
				goto yy298;
			}
		}
yy233:
		YYDEBUG(233, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'U') {
			if (yych == 'R') goto yy595;
			if (yych <= 'T') goto yy298;
			goto yy596;
		} else {
			if (yych <= 'r') {
				if (yych <= 'q') goto yy298;
				goto yy595;
			} else {
				if (yych == 'u') goto yy596;
				goto yy298;
			}
		}
yy234:
		YYDEBUG(234, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '<') {
			if (yych == '-') goto yy591;
		} else {
			if (yych <= '=') goto yy589;
			if (yych <= '>') goto yy593;
		}
yy235:
		YYDEBUG(235, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1322 "Zend/zend_language_scanner.l"
		{
	return yytext[0];
}
#line 3673 "Zend/zend_language_scanner.c"
yy236:
		YYDEBUG(236, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy588;
yy237:
		YYDEBUG(237, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1057 "Zend/zend_language_scanner.l"
		{
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	HANDLE_NEWLINES(yytext, yyleng);
	return T_WHITESPACE;
}
#line 3690 "Zend/zend_language_scanner.c"
yy238:
		YYDEBUG(238, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == ':') goto yy585;
		goto yy235;
yy239:
		YYDEBUG(239, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(240, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1086 "Zend/zend_language_scanner.l"
		{
	return T_NS_SEPARATOR;
}
#line 3705 "Zend/zend_language_scanner.c"
yy241:
		YYDEBUG(241, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'E') {
			if (yych == 'A') goto yy573;
			if (yych <= 'D') goto yy298;
			goto yy574;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy298;
				goto yy573;
			} else {
				if (yych == 'e') goto yy574;
				goto yy298;
			}
		}
yy242:
		YYDEBUG(242, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy570;
		if (yych == 'a') goto yy570;
		goto yy298;
yy243:
		YYDEBUG(243, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'D') {
				if (yych <= ' ') {
					if (yych == '\t') goto yy491;
					if (yych <= 0x1F) goto yy235;
					goto yy491;
				} else {
					if (yych <= '@') goto yy235;
					if (yych == 'C') goto yy235;
					goto yy491;
				}
			} else {
				if (yych <= 'I') {
					if (yych == 'F') goto yy491;
					if (yych <= 'H') goto yy235;
					goto yy491;
				} else {
					if (yych == 'O') goto yy491;
					if (yych <= 'Q') goto yy235;
					goto yy491;
				}
			}
		} else {
			if (yych <= 'f') {
				if (yych <= 'b') {
					if (yych == 'U') goto yy491;
					if (yych <= '`') goto yy235;
					goto yy491;
				} else {
					if (yych == 'd') goto yy491;
					if (yych <= 'e') goto yy235;
					goto yy491;
				}
			} else {
				if (yych <= 'o') {
					if (yych == 'i') goto yy491;
					if (yych <= 'n') goto yy235;
					goto yy491;
				} else {
					if (yych <= 's') {
						if (yych <= 'q') goto yy235;
						goto yy491;
					} else {
						if (yych == 'u') goto yy491;
						goto yy235;
					}
				}
			}
		}
yy244:
		YYDEBUG(244, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'S') {
			if (yych == 'N') goto yy482;
			if (yych <= 'R') goto yy298;
			goto yy483;
		} else {
			if (yych <= 'n') {
				if (yych <= 'm') goto yy298;
				goto yy482;
			} else {
				if (yych == 's') goto yy483;
				goto yy298;
			}
		}
yy245:
		YYDEBUG(245, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '_') goto yy408;
		goto yy298;
yy246:
		YYDEBUG(246, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy235;
		if (yych <= '=') goto yy402;
		if (yych <= '>') goto yy404;
		goto yy235;
yy247:
		YYDEBUG(247, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy398;
		if (yych == 'i') goto yy398;
		goto yy298;
yy248:
		YYDEBUG(248, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '+') goto yy396;
		if (yych == '=') goto yy394;
		goto yy235;
yy249:
		YYDEBUG(249, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy391;
		goto yy235;
yy250:
		YYDEBUG(250, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= ';') {
			if (yych == '/') goto yy363;
			goto yy235;
		} else {
			if (yych <= '<') goto yy361;
			if (yych <= '=') goto yy364;
			if (yych <= '>') goto yy366;
			goto yy235;
		}
yy251:
		YYDEBUG(251, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy235;
		if (yych <= '=') goto yy357;
		if (yych <= '>') goto yy355;
		goto yy235;
yy252:
		YYDEBUG(252, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy353;
		goto yy235;
yy253:
		YYDEBUG(253, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '.') {
			if (yych == '*') goto yy344;
			goto yy235;
		} else {
			if (yych <= '/') goto yy346;
			if (yych == '=') goto yy347;
			goto yy235;
		}
yy254:
		YYDEBUG(254, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '/') goto yy235;
		if (yych <= '9') goto yy340;
		if (yych == '=') goto yy342;
		goto yy235;
yy255:
		YYDEBUG(255, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy235;
		if (yych <= '=') goto yy336;
		if (yych <= '>') goto yy334;
		goto yy235;
yy256:
		YYDEBUG(256, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '&') goto yy330;
		if (yych == '=') goto yy332;
		goto yy235;
yy257:
		YYDEBUG(257, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy328;
		if (yych == '|') goto yy326;
		goto yy235;
yy258:
		YYDEBUG(258, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy324;
		goto yy235;
yy259:
		YYDEBUG(259, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy322;
		if (yych == 'r') goto yy322;
		goto yy298;
yy260:
		YYDEBUG(260, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy319;
		if (yych == 'o') goto yy319;
		goto yy298;
yy261:
		YYDEBUG(261, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy235;
			if (yych <= 'Z') goto yy316;
			if (yych <= '^') goto yy235;
			goto yy316;
		} else {
			if (yych <= '`') goto yy235;
			if (yych <= 'z') goto yy316;
			if (yych <= '~') goto yy235;
			goto yy316;
		}
yy262:
		YYDEBUG(262, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy235;
yy263:
		YYDEBUG(263, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy312;
		goto yy235;
yy264:
		YYDEBUG(264, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(265, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1327 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	return '{';
}
#line 3938 "Zend/zend_language_scanner.c"
yy266:
		YYDEBUG(266, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(267, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1339 "Zend/zend_language_scanner.l"
		{
	RESET_DOC_COMMENT();
	if (!zend_stack_is_empty(&SCNG(state_stack))) {
		yy_pop_state(TSRMLS_C);
	}
	return '}';
}
#line 3952 "Zend/zend_language_scanner.c"
yy268:
		YYDEBUG(268, *YYCURSOR);
		yyaccept = 2;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'E') {
			if (yych <= '/') {
				if (yych == '.') goto yy299;
			} else {
				if (yych <= '9') goto yy302;
				if (yych >= 'E') goto yy304;
			}
		} else {
			if (yych <= 'd') {
				if (yych == 'X') goto yy308;
			} else {
				if (yych <= 'e') goto yy304;
				if (yych == 'x') goto yy308;
			}
		}
yy269:
		YYDEBUG(269, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1365 "Zend/zend_language_scanner.l"
		{
	if (yyleng < MAX_LENGTH_OF_LONG - 1) { /* Won't overflow */
		zendlval->value.lval = strtol(yytext, NULL, 0);
	} else {
		errno = 0;
		zendlval->value.lval = strtol(yytext, NULL, 0);
		if (errno == ERANGE) { /* Overflow */
			if (yytext[0] == '0') { /* octal overflow */
				zendlval->value.dval = zend_oct_strtod(yytext, NULL);
			} else {
				zendlval->value.dval = zend_strtod(yytext, NULL);
			}
			zendlval->type = IS_DOUBLE;
			return T_DNUMBER;
		}
	}

	zendlval->type = IS_LONG;
	return T_LNUMBER;
}
#line 3996 "Zend/zend_language_scanner.c"
yy270:
		YYDEBUG(270, *YYCURSOR);
		yyaccept = 2;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '9') {
			if (yych == '.') goto yy299;
			if (yych <= '/') goto yy269;
			goto yy302;
		} else {
			if (yych <= 'E') {
				if (yych <= 'D') goto yy269;
				goto yy304;
			} else {
				if (yych == 'e') goto yy304;
				goto yy269;
			}
		}
yy271:
		YYDEBUG(271, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy298;
yy272:
		YYDEBUG(272, *YYCURSOR);
		++YYCURSOR;
yy273:
		YYDEBUG(273, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1710 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_ONE_LINE_COMMENT);
	yymore();
}
#line 4029 "Zend/zend_language_scanner.c"
yy274:
		YYDEBUG(274, *YYCURSOR);
		yyaccept = 3;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych >= 0x01) goto yy290;
yy275:
		YYDEBUG(275, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1882 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_DOUBLE_QUOTES);
	return '"';
}
#line 4043 "Zend/zend_language_scanner.c"
yy276:
		YYDEBUG(276, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych >= 0x01) goto yy282;
yy277:
		YYDEBUG(277, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2106 "Zend/zend_language_scanner.l"
		{
	zend_error(E_COMPILE_WARNING,"Unexpected character in input:  '%c' (ASCII=%d) state=%d", yytext[0], yytext[0], YYSTATE);
	goto restart;
}
#line 4057 "Zend/zend_language_scanner.c"
yy278:
		YYDEBUG(278, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(279, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1933 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_BACKQUOTE);
	return '`';
}
#line 4068 "Zend/zend_language_scanner.c"
yy280:
		YYDEBUG(280, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy277;
yy281:
		YYDEBUG(281, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy282:
		YYDEBUG(282, *YYCURSOR);
		if (yybm[256+yych] & 128) {
			goto yy281;
		}
		if (yych <= 0x00) goto yy283;
		if (yych <= '[') goto yy285;
		goto yy284;
yy283:
		YYDEBUG(283, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 3) {
			if (yyaccept <= 1) {
				if (yyaccept <= 0) {
					goto yy221;
				} else {
					goto yy235;
				}
			} else {
				if (yyaccept <= 2) {
					goto yy269;
				} else {
					goto yy275;
				}
			}
		} else {
			if (yyaccept <= 5) {
				if (yyaccept <= 4) {
					goto yy277;
				} else {
					goto yy301;
				}
			} else {
				if (yyaccept <= 6) {
					goto yy345;
				} else {
					goto yy362;
				}
			}
		}
yy284:
		YYDEBUG(284, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= 0x00) goto yy283;
		goto yy281;
yy285:
		YYDEBUG(285, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(286, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1831 "Zend/zend_language_scanner.l"
		{
	register char *s, *t;
	char *end;
	int bprefix = (yytext[0] != '\'') ? 1 : 0;

	zendlval->value.str.val = estrndup(yytext+bprefix+1, yyleng-bprefix-2);
	zendlval->value.str.len = yyleng-bprefix-2;
	zendlval->type = IS_STRING;

	/* convert escape sequences */
	s = t = zendlval->value.str.val;
	end = s+zendlval->value.str.len;
	while (s<end) {
		if (*s=='\\') {
			s++;

			switch(*s) {
				case '\\':
				case '\'':
					*t++ = *s;
					zendlval->value.str.len--;
					break;
				default:
					*t++ = '\\';
					*t++ = *s;
					break;
			}
		} else {
			*t++ = *s;
		}

		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
	}
	*t = 0;

#ifdef ZEND_MULTIBYTE
	if (SCNG(output_filter)) {
		size_t sz = 0;
		s = zendlval->value.str.val;
		SCNG(output_filter)((unsigned char **)&(zendlval->value.str.val), &sz, (unsigned char *)s, (size_t)zendlval->value.str.len TSRMLS_CC);
		zendlval->value.str.len = sz;
		efree(s);
	}
#endif /* ZEND_MULTIBYTE */
	return T_CONSTANT_ENCAPSED_STRING;
}
#line 4180 "Zend/zend_language_scanner.c"
yy287:
		YYDEBUG(287, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(288, *YYCURSOR);
		if (yybm[0+yych] & 2) {
			goto yy289;
		}
		if (yych <= 0x00) goto yy283;
		if (yych <= '#') goto yy294;
		if (yych <= '$') goto yy283;
		if (yych <= 'z') goto yy291;
		goto yy287;
yy289:
		YYDEBUG(289, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy290:
		YYDEBUG(290, *YYCURSOR);
		if (yybm[0+yych] & 2) {
			goto yy289;
		}
		if (yych <= 0x00) goto yy283;
		if (yych <= '#') goto yy294;
		if (yych <= '$') goto yy292;
		if (yych >= '{') goto yy287;
yy291:
		YYDEBUG(291, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= 0x00) goto yy283;
		goto yy289;
yy292:
		YYDEBUG(292, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(293, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy292;
		}
		if (yych <= '[') {
			if (yych <= '"') {
				if (yych <= 0x00) goto yy283;
				if (yych <= '!') goto yy289;
			} else {
				if (yych <= '@') goto yy289;
				if (yych <= 'Z') goto yy283;
				goto yy289;
			}
		} else {
			if (yych <= '_') {
				if (yych <= '\\') goto yy296;
				if (yych <= '^') goto yy289;
				goto yy283;
			} else {
				if (yych <= '`') goto yy289;
				if (yych <= '{') goto yy283;
				if (yych <= '~') goto yy289;
				goto yy283;
			}
		}
yy294:
		YYDEBUG(294, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(295, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1823 "Zend/zend_language_scanner.l"
		{
	int bprefix = (yytext[0] != '"') ? 1 : 0;

	zend_scan_escape_string(zendlval, yytext+bprefix+1, yyleng-bprefix-2, '"' TSRMLS_CC);
	return T_CONSTANT_ENCAPSED_STRING;
}
#line 4258 "Zend/zend_language_scanner.c"
yy296:
		YYDEBUG(296, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= 0x00) goto yy283;
		goto yy289;
yy297:
		YYDEBUG(297, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy298:
		YYDEBUG(298, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy297;
		}
		goto yy221;
yy299:
		YYDEBUG(299, *YYCURSOR);
		yyaccept = 5;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(300, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy299;
		}
		if (yych == 'E') goto yy304;
		if (yych == 'e') goto yy304;
yy301:
		YYDEBUG(301, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1426 "Zend/zend_language_scanner.l"
		{
	zendlval->value.dval = zend_strtod(yytext, NULL);
	zendlval->type = IS_DOUBLE;
	return T_DNUMBER;
}
#line 4298 "Zend/zend_language_scanner.c"
yy302:
		YYDEBUG(302, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(303, *YYCURSOR);
		if (yych <= '9') {
			if (yych == '.') goto yy299;
			if (yych <= '/') goto yy269;
			goto yy302;
		} else {
			if (yych <= 'E') {
				if (yych <= 'D') goto yy269;
			} else {
				if (yych != 'e') goto yy269;
			}
		}
yy304:
		YYDEBUG(304, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= ',') {
			if (yych != '+') goto yy283;
		} else {
			if (yych <= '-') goto yy305;
			if (yych <= '/') goto yy283;
			if (yych <= '9') goto yy306;
			goto yy283;
		}
yy305:
		YYDEBUG(305, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '/') goto yy283;
		if (yych >= ':') goto yy283;
yy306:
		YYDEBUG(306, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(307, *YYCURSOR);
		if (yych <= '/') goto yy301;
		if (yych <= '9') goto yy306;
		goto yy301;
yy308:
		YYDEBUG(308, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy309;
		}
		goto yy283;
yy309:
		YYDEBUG(309, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(310, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy309;
		}
		YYDEBUG(311, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1386 "Zend/zend_language_scanner.l"
		{
	char *hex = yytext + 2; /* Skip "0x" */
	int len = yyleng - 2;

	/* Skip any leading 0s */
	while (*hex == '0') {
		hex++;
		len--;
	}

	if (len < SIZEOF_LONG * 2 || (len == SIZEOF_LONG * 2 && *hex <= '7')) {
		zendlval->value.lval = strtol(hex, NULL, 16);
		zendlval->type = IS_LONG;
		return T_LNUMBER;
	} else {
		zendlval->value.dval = zend_hex_strtod(hex, NULL);
		zendlval->type = IS_DOUBLE;
		return T_DNUMBER;
	}
}
#line 4381 "Zend/zend_language_scanner.c"
yy312:
		YYDEBUG(312, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '\n') goto yy314;
		if (yych == '\r') goto yy315;
yy313:
		YYDEBUG(313, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1798 "Zend/zend_language_scanner.l"
		{
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	BEGIN(INITIAL);
	return T_CLOSE_TAG;  /* implicit ';' at php-end tag */
}
#line 4398 "Zend/zend_language_scanner.c"
yy314:
		YYDEBUG(314, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy313;
yy315:
		YYDEBUG(315, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy314;
		goto yy313;
yy316:
		YYDEBUG(316, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(317, *YYCURSOR);
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy316;
			} else {
				if (yych <= '@') goto yy318;
				if (yych <= 'Z') goto yy316;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy316;
			} else {
				if (yych <= 'z') goto yy316;
				if (yych >= 0x7F) goto yy316;
			}
		}
yy318:
		YYDEBUG(318, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1679 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 4438 "Zend/zend_language_scanner.c"
yy319:
		YYDEBUG(319, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy320;
		if (yych != 'r') goto yy298;
yy320:
		YYDEBUG(320, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(321, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1310 "Zend/zend_language_scanner.l"
		{
	return T_LOGICAL_XOR;
}
#line 4456 "Zend/zend_language_scanner.c"
yy322:
		YYDEBUG(322, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(323, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1302 "Zend/zend_language_scanner.l"
		{
	return T_LOGICAL_OR;
}
#line 4469 "Zend/zend_language_scanner.c"
yy324:
		YYDEBUG(324, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(325, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1290 "Zend/zend_language_scanner.l"
		{
	return T_XOR_EQUAL;
}
#line 4479 "Zend/zend_language_scanner.c"
yy326:
		YYDEBUG(326, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(327, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1294 "Zend/zend_language_scanner.l"
		{
	return T_BOOLEAN_OR;
}
#line 4489 "Zend/zend_language_scanner.c"
yy328:
		YYDEBUG(328, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(329, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1286 "Zend/zend_language_scanner.l"
		{
	return T_OR_EQUAL;
}
#line 4499 "Zend/zend_language_scanner.c"
yy330:
		YYDEBUG(330, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(331, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1298 "Zend/zend_language_scanner.l"
		{
	return T_BOOLEAN_AND;
}
#line 4509 "Zend/zend_language_scanner.c"
yy332:
		YYDEBUG(332, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(333, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1282 "Zend/zend_language_scanner.l"
		{
	return T_AND_EQUAL;
}
#line 4519 "Zend/zend_language_scanner.c"
yy334:
		YYDEBUG(334, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '\n') goto yy338;
		if (yych == '\r') goto yy339;
yy335:
		YYDEBUG(335, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1807 "Zend/zend_language_scanner.l"
		{
	if (CG(asp_tags)) {
		BEGIN(INITIAL);
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		zendlval->value.str.val = yytext; /* no copying - intentional */
		return T_CLOSE_TAG;  /* implicit ';' at php-end tag */
	} else {
		yyless(1);
		return yytext[0];
	}
}
#line 4541 "Zend/zend_language_scanner.c"
yy336:
		YYDEBUG(336, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(337, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1270 "Zend/zend_language_scanner.l"
		{
	return T_MOD_EQUAL;
}
#line 4551 "Zend/zend_language_scanner.c"
yy338:
		YYDEBUG(338, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy335;
yy339:
		YYDEBUG(339, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy338;
		goto yy335;
yy340:
		YYDEBUG(340, *YYCURSOR);
		yyaccept = 5;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(341, *YYCURSOR);
		if (yych <= 'D') {
			if (yych <= '/') goto yy301;
			if (yych <= '9') goto yy340;
			goto yy301;
		} else {
			if (yych <= 'E') goto yy304;
			if (yych == 'e') goto yy304;
			goto yy301;
		}
yy342:
		YYDEBUG(342, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(343, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1266 "Zend/zend_language_scanner.l"
		{
	return T_CONCAT_EQUAL;
}
#line 4586 "Zend/zend_language_scanner.c"
yy344:
		YYDEBUG(344, *YYCURSOR);
		yyaccept = 6;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '*') goto yy349;
yy345:
		YYDEBUG(345, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1770 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_COMMENT);
	yymore();
}
#line 4600 "Zend/zend_language_scanner.c"
yy346:
		YYDEBUG(346, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy273;
yy347:
		YYDEBUG(347, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(348, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1262 "Zend/zend_language_scanner.l"
		{
	return T_DIV_EQUAL;
}
#line 4614 "Zend/zend_language_scanner.c"
yy349:
		YYDEBUG(349, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 64) {
			goto yy350;
		}
		goto yy283;
yy350:
		YYDEBUG(350, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(351, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy350;
		}
		YYDEBUG(352, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1759 "Zend/zend_language_scanner.l"
		{
	RESET_DOC_COMMENT();
	BEGIN(ST_DOC_COMMENT);
	yymore();
}
#line 4639 "Zend/zend_language_scanner.c"
yy353:
		YYDEBUG(353, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(354, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1258 "Zend/zend_language_scanner.l"
		{
	return T_MUL_EQUAL;
}
#line 4649 "Zend/zend_language_scanner.c"
yy355:
		YYDEBUG(355, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy359;
		YYDEBUG(356, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1318 "Zend/zend_language_scanner.l"
		{
	return T_SR;
}
#line 4660 "Zend/zend_language_scanner.c"
yy357:
		YYDEBUG(357, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(358, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1246 "Zend/zend_language_scanner.l"
		{
	return T_IS_GREATER_OR_EQUAL;
}
#line 4670 "Zend/zend_language_scanner.c"
yy359:
		YYDEBUG(359, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(360, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1278 "Zend/zend_language_scanner.l"
		{
	return T_SR_EQUAL;
}
#line 4680 "Zend/zend_language_scanner.c"
yy361:
		YYDEBUG(361, *YYCURSOR);
		yyaccept = 7;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= ';') goto yy362;
		if (yych <= '<') goto yy377;
		if (yych <= '=') goto yy375;
yy362:
		YYDEBUG(362, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1314 "Zend/zend_language_scanner.l"
		{
	return T_SL;
}
#line 4695 "Zend/zend_language_scanner.c"
yy363:
		YYDEBUG(363, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy368;
		if (yych == 's') goto yy368;
		goto yy283;
yy364:
		YYDEBUG(364, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(365, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1242 "Zend/zend_language_scanner.l"
		{
	return T_IS_SMALLER_OR_EQUAL;
}
#line 4711 "Zend/zend_language_scanner.c"
yy366:
		YYDEBUG(366, *YYCURSOR);
		++YYCURSOR;
yy367:
		YYDEBUG(367, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1238 "Zend/zend_language_scanner.l"
		{
	return T_IS_NOT_EQUAL;
}
#line 4722 "Zend/zend_language_scanner.c"
yy368:
		YYDEBUG(368, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy369;
		if (yych != 'c') goto yy283;
yy369:
		YYDEBUG(369, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy370;
		if (yych != 'r') goto yy283;
yy370:
		YYDEBUG(370, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy371;
		if (yych != 'i') goto yy283;
yy371:
		YYDEBUG(371, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy372;
		if (yych != 'p') goto yy283;
yy372:
		YYDEBUG(372, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy373;
		if (yych != 't') goto yy283;
yy373:
		YYDEBUG(373, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(374, *YYCURSOR);
		if (yych <= '\r') {
			if (yych <= 0x08) goto yy283;
			if (yych <= '\n') goto yy373;
			if (yych <= '\f') goto yy283;
			goto yy373;
		} else {
			if (yych <= ' ') {
				if (yych <= 0x1F) goto yy283;
				goto yy373;
			} else {
				if (yych == '>') goto yy312;
				goto yy283;
			}
		}
yy375:
		YYDEBUG(375, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(376, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1274 "Zend/zend_language_scanner.l"
		{
	return T_SL_EQUAL;
}
#line 4777 "Zend/zend_language_scanner.c"
yy377:
		YYDEBUG(377, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(378, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy377;
		}
		if (yych <= 'Z') {
			if (yych <= '&') {
				if (yych == '"') goto yy382;
				goto yy283;
			} else {
				if (yych <= '\'') goto yy381;
				if (yych <= '@') goto yy283;
			}
		} else {
			if (yych <= '`') {
				if (yych != '_') goto yy283;
			} else {
				if (yych <= 'z') goto yy379;
				if (yych <= '~') goto yy283;
			}
		}
yy379:
		YYDEBUG(379, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(380, *YYCURSOR);
		if (yych <= '@') {
			if (yych <= '\f') {
				if (yych == '\n') goto yy386;
				goto yy283;
			} else {
				if (yych <= '\r') goto yy388;
				if (yych <= '/') goto yy283;
				if (yych <= '9') goto yy379;
				goto yy283;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy379;
				if (yych <= '^') goto yy283;
				goto yy379;
			} else {
				if (yych <= '`') goto yy283;
				if (yych <= 'z') goto yy379;
				if (yych <= '~') goto yy283;
				goto yy379;
			}
		}
yy381:
		YYDEBUG(381, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\'') goto yy283;
		if (yych <= '/') goto yy390;
		if (yych <= '9') goto yy283;
		goto yy390;
yy382:
		YYDEBUG(382, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '"') goto yy283;
		if (yych <= '/') goto yy384;
		if (yych <= '9') goto yy283;
		goto yy384;
yy383:
		YYDEBUG(383, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy384:
		YYDEBUG(384, *YYCURSOR);
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych != '"') goto yy283;
			} else {
				if (yych <= '9') goto yy383;
				if (yych <= '@') goto yy283;
				goto yy383;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy383;
				goto yy283;
			} else {
				if (yych <= 'z') goto yy383;
				if (yych <= '~') goto yy283;
				goto yy383;
			}
		}
yy385:
		YYDEBUG(385, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy386;
		if (yych == '\r') goto yy388;
		goto yy283;
yy386:
		YYDEBUG(386, *YYCURSOR);
		++YYCURSOR;
yy387:
		YYDEBUG(387, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1888 "Zend/zend_language_scanner.l"
		{
	char *s;
	int bprefix = (yytext[0] != '<') ? 1 : 0;

	CG(zend_lineno)++;
	CG(heredoc_len) = yyleng-bprefix-3-1-(yytext[yyleng-2]=='\r'?1:0);
	s = yytext+bprefix+3;
	while ((*s == ' ') || (*s == '\t')) {
		s++;
		CG(heredoc_len)--;
	}

	if (*s == '\'') {
		s++;
		CG(heredoc_len) -= 2;

		BEGIN(ST_NOWDOC);
	} else {
		if (*s == '"') {
			s++;
			CG(heredoc_len) -= 2;
		}

		BEGIN(ST_HEREDOC);
	}

	CG(heredoc) = estrndup(s, CG(heredoc_len));

	/* Check for ending label on the next line */
	if (CG(heredoc_len) < YYLIMIT - YYCURSOR && !memcmp(YYCURSOR, s, CG(heredoc_len))) {
		unsigned char *end = YYCURSOR + CG(heredoc_len);

		if (*end == ';') {
			end++;
		}

		if (*end == '\n' || *end == '\r') {
			BEGIN(ST_END_HEREDOC);
		}
	}

	return T_START_HEREDOC;
}
#line 4926 "Zend/zend_language_scanner.c"
yy388:
		YYDEBUG(388, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy386;
		goto yy387;
yy389:
		YYDEBUG(389, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy390:
		YYDEBUG(390, *YYCURSOR);
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych == '\'') goto yy385;
				goto yy283;
			} else {
				if (yych <= '9') goto yy389;
				if (yych <= '@') goto yy283;
				goto yy389;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy389;
				goto yy283;
			} else {
				if (yych <= 'z') goto yy389;
				if (yych <= '~') goto yy283;
				goto yy389;
			}
		}
yy391:
		YYDEBUG(391, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '=') goto yy367;
		YYDEBUG(392, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(393, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1230 "Zend/zend_language_scanner.l"
		{
	return T_IS_NOT_IDENTICAL;
}
#line 4970 "Zend/zend_language_scanner.c"
yy394:
		YYDEBUG(394, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(395, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1250 "Zend/zend_language_scanner.l"
		{
	return T_PLUS_EQUAL;
}
#line 4980 "Zend/zend_language_scanner.c"
yy396:
		YYDEBUG(396, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(397, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1218 "Zend/zend_language_scanner.l"
		{
	return T_INC;
}
#line 4990 "Zend/zend_language_scanner.c"
yy398:
		YYDEBUG(398, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy399;
		if (yych != 's') goto yy298;
yy399:
		YYDEBUG(399, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy400;
		if (yych != 't') goto yy298;
yy400:
		YYDEBUG(400, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(401, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1210 "Zend/zend_language_scanner.l"
		{
	return T_LIST;
}
#line 5013 "Zend/zend_language_scanner.c"
yy402:
		YYDEBUG(402, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy406;
		YYDEBUG(403, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1234 "Zend/zend_language_scanner.l"
		{
	return T_IS_EQUAL;
}
#line 5024 "Zend/zend_language_scanner.c"
yy404:
		YYDEBUG(404, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(405, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1206 "Zend/zend_language_scanner.l"
		{
	return T_DOUBLE_ARROW;
}
#line 5034 "Zend/zend_language_scanner.c"
yy406:
		YYDEBUG(406, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(407, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1226 "Zend/zend_language_scanner.l"
		{
	return T_IS_IDENTICAL;
}
#line 5044 "Zend/zend_language_scanner.c"
yy408:
		YYDEBUG(408, *YYCURSOR);
		yych = *++YYCURSOR;
		YYDEBUG(-1, yych);
		switch (yych) {
		case 'C':
		case 'c':	goto yy410;
		case 'D':
		case 'd':	goto yy414;
		case 'F':
		case 'f':	goto yy411;
		case 'H':
		case 'h':	goto yy409;
		case 'L':
		case 'l':	goto yy413;
		case 'M':
		case 'm':	goto yy412;
		case 'N':
		case 'n':	goto yy415;
		default:	goto yy298;
		}
yy409:
		YYDEBUG(409, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy469;
		if (yych == 'a') goto yy469;
		goto yy298;
yy410:
		YYDEBUG(410, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy462;
		if (yych == 'l') goto yy462;
		goto yy298;
yy411:
		YYDEBUG(411, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'U') {
			if (yych == 'I') goto yy446;
			if (yych <= 'T') goto yy298;
			goto yy447;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy298;
				goto yy446;
			} else {
				if (yych == 'u') goto yy447;
				goto yy298;
			}
		}
yy412:
		YYDEBUG(412, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy438;
		if (yych == 'e') goto yy438;
		goto yy298;
yy413:
		YYDEBUG(413, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy432;
		if (yych == 'i') goto yy432;
		goto yy298;
yy414:
		YYDEBUG(414, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy427;
		if (yych == 'i') goto yy427;
		goto yy298;
yy415:
		YYDEBUG(415, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy416;
		if (yych != 'a') goto yy298;
yy416:
		YYDEBUG(416, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy417;
		if (yych != 'm') goto yy298;
yy417:
		YYDEBUG(417, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy418;
		if (yych != 'e') goto yy298;
yy418:
		YYDEBUG(418, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy419;
		if (yych != 's') goto yy298;
yy419:
		YYDEBUG(419, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy420;
		if (yych != 'p') goto yy298;
yy420:
		YYDEBUG(420, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy421;
		if (yych != 'a') goto yy298;
yy421:
		YYDEBUG(421, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy422;
		if (yych != 'c') goto yy298;
yy422:
		YYDEBUG(422, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy423;
		if (yych != 'e') goto yy298;
yy423:
		YYDEBUG(423, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(424, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(425, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(426, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1530 "Zend/zend_language_scanner.l"
		{
	if (CG(current_namespace)) {
		*zendlval = *CG(current_namespace);
		zval_copy_ctor(zendlval);
	} else {
		ZVAL_EMPTY_STRING(zendlval);
	}
	return T_NS_C;
}
#line 5176 "Zend/zend_language_scanner.c"
yy427:
		YYDEBUG(427, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy428;
		if (yych != 'r') goto yy298;
yy428:
		YYDEBUG(428, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(429, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(430, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(431, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1503 "Zend/zend_language_scanner.l"
		{
	char *filename = zend_get_compiled_filename(TSRMLS_C);
	const size_t filename_len = strlen(filename);
	char *dirname;

	if (!filename) {
		filename = "";
	}

	dirname = estrndup(filename, filename_len);
	zend_dirname(dirname, filename_len);

	if (strcmp(dirname, ".") == 0) {
		dirname = erealloc(dirname, MAXPATHLEN);
#if HAVE_GETCWD
		VCWD_GETCWD(dirname, MAXPATHLEN);
#elif HAVE_GETWD
		VCWD_GETWD(dirname);
#endif
	}

	zendlval->value.str.len = strlen(dirname);
	zendlval->value.str.val = dirname;
	zendlval->type = IS_STRING;
	return T_DIR;
}
#line 5223 "Zend/zend_language_scanner.c"
yy432:
		YYDEBUG(432, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy433;
		if (yych != 'n') goto yy298;
yy433:
		YYDEBUG(433, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy434;
		if (yych != 'e') goto yy298;
yy434:
		YYDEBUG(434, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(435, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(436, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(437, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1485 "Zend/zend_language_scanner.l"
		{
	zendlval->value.lval = CG(zend_lineno);
	zendlval->type = IS_LONG;
	return T_LINE;
}
#line 5254 "Zend/zend_language_scanner.c"
yy438:
		YYDEBUG(438, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy439;
		if (yych != 't') goto yy298;
yy439:
		YYDEBUG(439, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy440;
		if (yych != 'h') goto yy298;
yy440:
		YYDEBUG(440, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy441;
		if (yych != 'o') goto yy298;
yy441:
		YYDEBUG(441, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy442;
		if (yych != 'd') goto yy298;
yy442:
		YYDEBUG(442, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(443, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(444, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(445, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1464 "Zend/zend_language_scanner.l"
		{
	char *class_name = CG(active_class_entry) ? CG(active_class_entry)->name : NULL;
	char *func_name = CG(active_op_array)? CG(active_op_array)->function_name : NULL;
	size_t len = 0;

	if (class_name) {
		len += strlen(class_name) + 2;
	}
	if (func_name) {
		len += strlen(func_name);
	}

	zendlval->value.str.len = zend_spprintf(&zendlval->value.str.val, 0, "%s%s%s", 
		class_name ? class_name : "",
		class_name && func_name ? "::" : "",
		func_name ? func_name : ""
		);
	zendlval->type = IS_STRING;
	return T_METHOD_C;
}
#line 5310 "Zend/zend_language_scanner.c"
yy446:
		YYDEBUG(446, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy457;
		if (yych == 'l') goto yy457;
		goto yy298;
yy447:
		YYDEBUG(447, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy448;
		if (yych != 'n') goto yy298;
yy448:
		YYDEBUG(448, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy449;
		if (yych != 'c') goto yy298;
yy449:
		YYDEBUG(449, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy450;
		if (yych != 't') goto yy298;
yy450:
		YYDEBUG(450, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy451;
		if (yych != 'i') goto yy298;
yy451:
		YYDEBUG(451, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy452;
		if (yych != 'o') goto yy298;
yy452:
		YYDEBUG(452, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy453;
		if (yych != 'n') goto yy298;
yy453:
		YYDEBUG(453, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(454, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(455, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(456, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1448 "Zend/zend_language_scanner.l"
		{
	char *func_name = NULL;

	if (CG(active_op_array)) {
		func_name = CG(active_op_array)->function_name;
	}

	if (!func_name) {
		func_name = "";
	}
	zendlval->value.str.len = strlen(func_name);
	zendlval->value.str.val = estrndup(func_name, zendlval->value.str.len);
	zendlval->type = IS_STRING;
	return T_FUNC_C;
}
#line 5377 "Zend/zend_language_scanner.c"
yy457:
		YYDEBUG(457, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy458;
		if (yych != 'e') goto yy298;
yy458:
		YYDEBUG(458, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(459, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(460, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(461, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1491 "Zend/zend_language_scanner.l"
		{
	char *filename = zend_get_compiled_filename(TSRMLS_C);

	if (!filename) {
		filename = "";
	}
	zendlval->value.str.len = strlen(filename);
	zendlval->value.str.val = estrndup(filename, zendlval->value.str.len);
	zendlval->type = IS_STRING;
	return T_FILE;
}
#line 5409 "Zend/zend_language_scanner.c"
yy462:
		YYDEBUG(462, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy463;
		if (yych != 'a') goto yy298;
yy463:
		YYDEBUG(463, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy464;
		if (yych != 's') goto yy298;
yy464:
		YYDEBUG(464, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy465;
		if (yych != 's') goto yy298;
yy465:
		YYDEBUG(465, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(466, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(467, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(468, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1432 "Zend/zend_language_scanner.l"
		{
	char *class_name = NULL;

	if (CG(active_class_entry)) {
		class_name = CG(active_class_entry)->name;
	}

	if (!class_name) {
		class_name = "";
	}
	zendlval->value.str.len = strlen(class_name);
	zendlval->value.str.val = estrndup(class_name, zendlval->value.str.len);
	zendlval->type = IS_STRING;
	return T_CLASS_C;
}
#line 5455 "Zend/zend_language_scanner.c"
yy469:
		YYDEBUG(469, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy470;
		if (yych != 'l') goto yy298;
yy470:
		YYDEBUG(470, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy471;
		if (yych != 't') goto yy298;
yy471:
		YYDEBUG(471, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy298;
		YYDEBUG(472, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy473;
		if (yych != 'c') goto yy298;
yy473:
		YYDEBUG(473, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy474;
		if (yych != 'o') goto yy298;
yy474:
		YYDEBUG(474, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy475;
		if (yych != 'm') goto yy298;
yy475:
		YYDEBUG(475, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy476;
		if (yych != 'p') goto yy298;
yy476:
		YYDEBUG(476, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy477;
		if (yych != 'i') goto yy298;
yy477:
		YYDEBUG(477, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy478;
		if (yych != 'l') goto yy298;
yy478:
		YYDEBUG(478, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy479;
		if (yych != 'e') goto yy298;
yy479:
		YYDEBUG(479, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy480;
		if (yych != 'r') goto yy298;
yy480:
		YYDEBUG(480, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(481, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1174 "Zend/zend_language_scanner.l"
		{
	return T_HALT_COMPILER;
}
#line 5521 "Zend/zend_language_scanner.c"
yy482:
		YYDEBUG(482, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy486;
		if (yych == 's') goto yy486;
		goto yy298;
yy483:
		YYDEBUG(483, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy484;
		if (yych != 'e') goto yy298;
yy484:
		YYDEBUG(484, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(485, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1158 "Zend/zend_language_scanner.l"
		{
	return T_USE;
}
#line 5545 "Zend/zend_language_scanner.c"
yy486:
		YYDEBUG(486, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy487;
		if (yych != 'e') goto yy298;
yy487:
		YYDEBUG(487, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy488;
		if (yych != 't') goto yy298;
yy488:
		YYDEBUG(488, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(489, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1202 "Zend/zend_language_scanner.l"
		{
	return T_UNSET;
}
#line 5568 "Zend/zend_language_scanner.c"
yy490:
		YYDEBUG(490, *YYCURSOR);
		++YYCURSOR;
		YYFILL(7);
		yych = *YYCURSOR;
yy491:
		YYDEBUG(491, *YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'D') {
				if (yych <= ' ') {
					if (yych == '\t') goto yy490;
					if (yych <= 0x1F) goto yy283;
					goto yy490;
				} else {
					if (yych <= 'A') {
						if (yych <= '@') goto yy283;
						goto yy495;
					} else {
						if (yych <= 'B') goto yy493;
						if (yych <= 'C') goto yy283;
						goto yy498;
					}
				}
			} else {
				if (yych <= 'I') {
					if (yych == 'F') goto yy499;
					if (yych <= 'H') goto yy283;
					goto yy500;
				} else {
					if (yych <= 'O') {
						if (yych <= 'N') goto yy283;
						goto yy494;
					} else {
						if (yych <= 'Q') goto yy283;
						if (yych <= 'R') goto yy497;
						goto yy496;
					}
				}
			}
		} else {
			if (yych <= 'f') {
				if (yych <= 'a') {
					if (yych == 'U') goto yy492;
					if (yych <= '`') goto yy283;
					goto yy495;
				} else {
					if (yych <= 'c') {
						if (yych <= 'b') goto yy493;
						goto yy283;
					} else {
						if (yych <= 'd') goto yy498;
						if (yych <= 'e') goto yy283;
						goto yy499;
					}
				}
			} else {
				if (yych <= 'q') {
					if (yych <= 'i') {
						if (yych <= 'h') goto yy283;
						goto yy500;
					} else {
						if (yych == 'o') goto yy494;
						goto yy283;
					}
				} else {
					if (yych <= 's') {
						if (yych <= 'r') goto yy497;
						goto yy496;
					} else {
						if (yych != 'u') goto yy283;
					}
				}
			}
		}
yy492:
		YYDEBUG(492, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy563;
		if (yych == 'n') goto yy563;
		goto yy283;
yy493:
		YYDEBUG(493, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'I') goto yy546;
			if (yych <= 'N') goto yy283;
			goto yy547;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy283;
				goto yy546;
			} else {
				if (yych == 'o') goto yy547;
				goto yy283;
			}
		}
yy494:
		YYDEBUG(494, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy538;
		if (yych == 'b') goto yy538;
		goto yy283;
yy495:
		YYDEBUG(495, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy531;
		if (yych == 'r') goto yy531;
		goto yy283;
yy496:
		YYDEBUG(496, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy523;
		if (yych == 't') goto yy523;
		goto yy283;
yy497:
		YYDEBUG(497, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy521;
		if (yych == 'e') goto yy521;
		goto yy283;
yy498:
		YYDEBUG(498, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy517;
		if (yych == 'o') goto yy517;
		goto yy283;
yy499:
		YYDEBUG(499, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy510;
		if (yych == 'l') goto yy510;
		goto yy283;
yy500:
		YYDEBUG(500, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy501;
		if (yych != 'n') goto yy283;
yy501:
		YYDEBUG(501, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy502;
		if (yych != 't') goto yy283;
yy502:
		YYDEBUG(502, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy503;
		if (yych != 'e') goto yy505;
yy503:
		YYDEBUG(503, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy508;
		if (yych == 'g') goto yy508;
		goto yy283;
yy504:
		YYDEBUG(504, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy505:
		YYDEBUG(505, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy504;
			goto yy283;
		} else {
			if (yych <= ' ') goto yy504;
			if (yych != ')') goto yy283;
		}
		YYDEBUG(506, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(507, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1102 "Zend/zend_language_scanner.l"
		{
	return T_INT_CAST;
}
#line 5744 "Zend/zend_language_scanner.c"
yy508:
		YYDEBUG(508, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy509;
		if (yych != 'e') goto yy283;
yy509:
		YYDEBUG(509, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy504;
		if (yych == 'r') goto yy504;
		goto yy283;
yy510:
		YYDEBUG(510, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy511;
		if (yych != 'o') goto yy283;
yy511:
		YYDEBUG(511, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy512;
		if (yych != 'a') goto yy283;
yy512:
		YYDEBUG(512, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy513;
		if (yych != 't') goto yy283;
yy513:
		YYDEBUG(513, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(514, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy513;
			goto yy283;
		} else {
			if (yych <= ' ') goto yy513;
			if (yych != ')') goto yy283;
		}
		YYDEBUG(515, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(516, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1106 "Zend/zend_language_scanner.l"
		{
	return T_DOUBLE_CAST;
}
#line 5792 "Zend/zend_language_scanner.c"
yy517:
		YYDEBUG(517, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy518;
		if (yych != 'u') goto yy283;
yy518:
		YYDEBUG(518, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy519;
		if (yych != 'b') goto yy283;
yy519:
		YYDEBUG(519, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy520;
		if (yych != 'l') goto yy283;
yy520:
		YYDEBUG(520, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy513;
		if (yych == 'e') goto yy513;
		goto yy283;
yy521:
		YYDEBUG(521, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy522;
		if (yych != 'a') goto yy283;
yy522:
		YYDEBUG(522, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy513;
		if (yych == 'l') goto yy513;
		goto yy283;
yy523:
		YYDEBUG(523, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy524;
		if (yych != 'r') goto yy283;
yy524:
		YYDEBUG(524, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy525;
		if (yych != 'i') goto yy283;
yy525:
		YYDEBUG(525, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy526;
		if (yych != 'n') goto yy283;
yy526:
		YYDEBUG(526, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy527;
		if (yych != 'g') goto yy283;
yy527:
		YYDEBUG(527, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(528, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy527;
			goto yy283;
		} else {
			if (yych <= ' ') goto yy527;
			if (yych != ')') goto yy283;
		}
		YYDEBUG(529, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(530, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1110 "Zend/zend_language_scanner.l"
		{
	return T_STRING_CAST;
}
#line 5866 "Zend/zend_language_scanner.c"
yy531:
		YYDEBUG(531, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy532;
		if (yych != 'r') goto yy283;
yy532:
		YYDEBUG(532, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy533;
		if (yych != 'a') goto yy283;
yy533:
		YYDEBUG(533, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy534;
		if (yych != 'y') goto yy283;
yy534:
		YYDEBUG(534, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(535, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy534;
			goto yy283;
		} else {
			if (yych <= ' ') goto yy534;
			if (yych != ')') goto yy283;
		}
		YYDEBUG(536, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(537, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1118 "Zend/zend_language_scanner.l"
		{
	return T_ARRAY_CAST;
}
#line 5903 "Zend/zend_language_scanner.c"
yy538:
		YYDEBUG(538, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'J') goto yy539;
		if (yych != 'j') goto yy283;
yy539:
		YYDEBUG(539, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy540;
		if (yych != 'e') goto yy283;
yy540:
		YYDEBUG(540, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy541;
		if (yych != 'c') goto yy283;
yy541:
		YYDEBUG(541, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy542;
		if (yych != 't') goto yy283;
yy542:
		YYDEBUG(542, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(543, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy542;
			goto yy283;
		} else {
			if (yych <= ' ') goto yy542;
			if (yych != ')') goto yy283;
		}
		YYDEBUG(544, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(545, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1122 "Zend/zend_language_scanner.l"
		{
	return T_OBJECT_CAST;
}
#line 5945 "Zend/zend_language_scanner.c"
yy546:
		YYDEBUG(546, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy556;
		if (yych == 'n') goto yy556;
		goto yy283;
yy547:
		YYDEBUG(547, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy548;
		if (yych != 'o') goto yy283;
yy548:
		YYDEBUG(548, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy549;
		if (yych != 'l') goto yy283;
yy549:
		YYDEBUG(549, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy554;
		if (yych == 'e') goto yy554;
		goto yy551;
yy550:
		YYDEBUG(550, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy551:
		YYDEBUG(551, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy550;
			goto yy283;
		} else {
			if (yych <= ' ') goto yy550;
			if (yych != ')') goto yy283;
		}
		YYDEBUG(552, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(553, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1126 "Zend/zend_language_scanner.l"
		{
	return T_BOOL_CAST;
}
#line 5990 "Zend/zend_language_scanner.c"
yy554:
		YYDEBUG(554, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy555;
		if (yych != 'a') goto yy283;
yy555:
		YYDEBUG(555, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy550;
		if (yych == 'n') goto yy550;
		goto yy283;
yy556:
		YYDEBUG(556, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy557;
		if (yych != 'a') goto yy283;
yy557:
		YYDEBUG(557, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy558;
		if (yych != 'r') goto yy283;
yy558:
		YYDEBUG(558, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy559;
		if (yych != 'y') goto yy283;
yy559:
		YYDEBUG(559, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(560, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy559;
			goto yy283;
		} else {
			if (yych <= ' ') goto yy559;
			if (yych != ')') goto yy283;
		}
		YYDEBUG(561, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(562, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1114 "Zend/zend_language_scanner.l"
		{
	return T_STRING_CAST;
}
#line 6038 "Zend/zend_language_scanner.c"
yy563:
		YYDEBUG(563, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy564;
		if (yych != 's') goto yy283;
yy564:
		YYDEBUG(564, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy565;
		if (yych != 'e') goto yy283;
yy565:
		YYDEBUG(565, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy566;
		if (yych != 't') goto yy283;
yy566:
		YYDEBUG(566, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(567, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy566;
			goto yy283;
		} else {
			if (yych <= ' ') goto yy566;
			if (yych != ')') goto yy283;
		}
		YYDEBUG(568, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(569, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1130 "Zend/zend_language_scanner.l"
		{
	return T_UNSET_CAST;
}
#line 6075 "Zend/zend_language_scanner.c"
yy570:
		YYDEBUG(570, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy571;
		if (yych != 'r') goto yy298;
yy571:
		YYDEBUG(571, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(572, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1098 "Zend/zend_language_scanner.l"
		{
	return T_VAR;
}
#line 6093 "Zend/zend_language_scanner.c"
yy573:
		YYDEBUG(573, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy577;
		if (yych == 'm') goto yy577;
		goto yy298;
yy574:
		YYDEBUG(574, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'W') goto yy575;
		if (yych != 'w') goto yy298;
yy575:
		YYDEBUG(575, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(576, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1090 "Zend/zend_language_scanner.l"
		{
	return T_NEW;
}
#line 6117 "Zend/zend_language_scanner.c"
yy577:
		YYDEBUG(577, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy578;
		if (yych != 'e') goto yy298;
yy578:
		YYDEBUG(578, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy579;
		if (yych != 's') goto yy298;
yy579:
		YYDEBUG(579, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy580;
		if (yych != 'p') goto yy298;
yy580:
		YYDEBUG(580, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy581;
		if (yych != 'a') goto yy298;
yy581:
		YYDEBUG(581, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy582;
		if (yych != 'c') goto yy298;
yy582:
		YYDEBUG(582, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy583;
		if (yych != 'e') goto yy298;
yy583:
		YYDEBUG(583, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(584, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1154 "Zend/zend_language_scanner.l"
		{
	return T_NAMESPACE;
}
#line 6160 "Zend/zend_language_scanner.c"
yy585:
		YYDEBUG(585, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(586, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1082 "Zend/zend_language_scanner.l"
		{
	return T_PAAMAYIM_NEKUDOTAYIM;
}
#line 6170 "Zend/zend_language_scanner.c"
yy587:
		YYDEBUG(587, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy588:
		YYDEBUG(588, *YYCURSOR);
		if (yych <= '\f') {
			if (yych <= 0x08) goto yy237;
			if (yych <= '\n') goto yy587;
			goto yy237;
		} else {
			if (yych <= '\r') goto yy587;
			if (yych == ' ') goto yy587;
			goto yy237;
		}
yy589:
		YYDEBUG(589, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(590, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1254 "Zend/zend_language_scanner.l"
		{
	return T_MINUS_EQUAL;
}
#line 6196 "Zend/zend_language_scanner.c"
yy591:
		YYDEBUG(591, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(592, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1222 "Zend/zend_language_scanner.l"
		{
	return T_DEC;
}
#line 6206 "Zend/zend_language_scanner.c"
yy593:
		YYDEBUG(593, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(594, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1052 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_PROPERTY TSRMLS_CC);
	return T_OBJECT_OPERATOR;
}
#line 6217 "Zend/zend_language_scanner.c"
yy595:
		YYDEBUG(595, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'I') goto yy602;
			if (yych <= 'N') goto yy298;
			goto yy603;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy298;
				goto yy602;
			} else {
				if (yych == 'o') goto yy603;
				goto yy298;
			}
		}
yy596:
		YYDEBUG(596, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy597;
		if (yych != 'b') goto yy298;
yy597:
		YYDEBUG(597, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy598;
		if (yych != 'l') goto yy298;
yy598:
		YYDEBUG(598, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy599;
		if (yych != 'i') goto yy298;
yy599:
		YYDEBUG(599, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy600;
		if (yych != 'c') goto yy298;
yy600:
		YYDEBUG(600, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(601, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1198 "Zend/zend_language_scanner.l"
		{
	return T_PUBLIC;
}
#line 6266 "Zend/zend_language_scanner.c"
yy602:
		YYDEBUG(602, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'V') {
			if (yych == 'N') goto yy611;
			if (yych <= 'U') goto yy298;
			goto yy612;
		} else {
			if (yych <= 'n') {
				if (yych <= 'm') goto yy298;
				goto yy611;
			} else {
				if (yych == 'v') goto yy612;
				goto yy298;
			}
		}
yy603:
		YYDEBUG(603, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy604;
		if (yych != 't') goto yy298;
yy604:
		YYDEBUG(604, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy605;
		if (yych != 'e') goto yy298;
yy605:
		YYDEBUG(605, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy606;
		if (yych != 'c') goto yy298;
yy606:
		YYDEBUG(606, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy607;
		if (yych != 't') goto yy298;
yy607:
		YYDEBUG(607, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy608;
		if (yych != 'e') goto yy298;
yy608:
		YYDEBUG(608, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy609;
		if (yych != 'd') goto yy298;
yy609:
		YYDEBUG(609, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(610, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1194 "Zend/zend_language_scanner.l"
		{
	return T_PROTECTED;
}
#line 6325 "Zend/zend_language_scanner.c"
yy611:
		YYDEBUG(611, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy617;
		if (yych == 't') goto yy617;
		goto yy298;
yy612:
		YYDEBUG(612, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy613;
		if (yych != 'a') goto yy298;
yy613:
		YYDEBUG(613, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy614;
		if (yych != 't') goto yy298;
yy614:
		YYDEBUG(614, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy615;
		if (yych != 'e') goto yy298;
yy615:
		YYDEBUG(615, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(616, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1190 "Zend/zend_language_scanner.l"
		{
	return T_PRIVATE;
}
#line 6359 "Zend/zend_language_scanner.c"
yy617:
		YYDEBUG(617, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(618, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1032 "Zend/zend_language_scanner.l"
		{
	return T_PRINT;
}
#line 6372 "Zend/zend_language_scanner.c"
yy619:
		YYDEBUG(619, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy624;
		if (yych == 'o') goto yy624;
		goto yy298;
yy620:
		YYDEBUG(620, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy621;
		if (yych != 't') goto yy298;
yy621:
		YYDEBUG(621, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy622;
		if (yych != 'o') goto yy298;
yy622:
		YYDEBUG(622, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(623, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1024 "Zend/zend_language_scanner.l"
		{
	return T_GOTO;
}
#line 6401 "Zend/zend_language_scanner.c"
yy624:
		YYDEBUG(624, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy625;
		if (yych != 'b') goto yy298;
yy625:
		YYDEBUG(625, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy626;
		if (yych != 'a') goto yy298;
yy626:
		YYDEBUG(626, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy627;
		if (yych != 'l') goto yy298;
yy627:
		YYDEBUG(627, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(628, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1162 "Zend/zend_language_scanner.l"
		{
	return T_GLOBAL;
}
#line 6429 "Zend/zend_language_scanner.c"
yy629:
		YYDEBUG(629, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '<') goto yy636;
		goto yy283;
yy630:
		YYDEBUG(630, *YYCURSOR);
		yyaccept = 3;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 0x00) goto yy275;
		goto yy290;
yy631:
		YYDEBUG(631, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy632;
		if (yych != 'e') goto yy298;
yy632:
		YYDEBUG(632, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy633;
		if (yych != 'a') goto yy298;
yy633:
		YYDEBUG(633, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'K') goto yy634;
		if (yych != 'k') goto yy298;
yy634:
		YYDEBUG(634, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(635, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1016 "Zend/zend_language_scanner.l"
		{
	return T_BREAK;
}
#line 6468 "Zend/zend_language_scanner.c"
yy636:
		YYDEBUG(636, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '<') goto yy377;
		goto yy283;
yy637:
		YYDEBUG(637, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy644;
		if (yych == 'a') goto yy644;
		goto yy298;
yy638:
		YYDEBUG(638, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy639;
		if (yych != 'i') goto yy298;
yy639:
		YYDEBUG(639, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy640;
		if (yych != 't') goto yy298;
yy640:
		YYDEBUG(640, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy641;
		if (yych != 'c') goto yy298;
yy641:
		YYDEBUG(641, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy642;
		if (yych != 'h') goto yy298;
yy642:
		YYDEBUG(642, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(643, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1000 "Zend/zend_language_scanner.l"
		{
	return T_SWITCH;
}
#line 6512 "Zend/zend_language_scanner.c"
yy644:
		YYDEBUG(644, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy645;
		if (yych != 't') goto yy298;
yy645:
		YYDEBUG(645, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy646;
		if (yych != 'i') goto yy298;
yy646:
		YYDEBUG(646, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy647;
		if (yych != 'c') goto yy298;
yy647:
		YYDEBUG(647, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(648, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1178 "Zend/zend_language_scanner.l"
		{
	return T_STATIC;
}
#line 6540 "Zend/zend_language_scanner.c"
yy649:
		YYDEBUG(649, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy660;
		if (yych == 's') goto yy660;
		goto yy298;
yy650:
		YYDEBUG(650, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy658;
		if (yych == 'd') goto yy658;
		goto yy298;
yy651:
		YYDEBUG(651, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy654;
		if (yych == 'r') goto yy654;
		goto yy298;
yy652:
		YYDEBUG(652, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(653, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 996 "Zend/zend_language_scanner.l"
		{
	return T_AS;
}
#line 6571 "Zend/zend_language_scanner.c"
yy654:
		YYDEBUG(654, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy655;
		if (yych != 'a') goto yy298;
yy655:
		YYDEBUG(655, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy656;
		if (yych != 'y') goto yy298;
yy656:
		YYDEBUG(656, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(657, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1214 "Zend/zend_language_scanner.l"
		{
	return T_ARRAY;
}
#line 6594 "Zend/zend_language_scanner.c"
yy658:
		YYDEBUG(658, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(659, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1306 "Zend/zend_language_scanner.l"
		{
	return T_LOGICAL_AND;
}
#line 6607 "Zend/zend_language_scanner.c"
yy660:
		YYDEBUG(660, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy661;
		if (yych != 't') goto yy298;
yy661:
		YYDEBUG(661, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy662;
		if (yych != 'r') goto yy298;
yy662:
		YYDEBUG(662, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy663;
		if (yych != 'a') goto yy298;
yy663:
		YYDEBUG(663, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy664;
		if (yych != 'c') goto yy298;
yy664:
		YYDEBUG(664, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy665;
		if (yych != 't') goto yy298;
yy665:
		YYDEBUG(665, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(666, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1182 "Zend/zend_language_scanner.l"
		{
	return T_ABSTRACT;
}
#line 6645 "Zend/zend_language_scanner.c"
yy667:
		YYDEBUG(667, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy668;
		if (yych != 'i') goto yy298;
yy668:
		YYDEBUG(668, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy669;
		if (yych != 'l') goto yy298;
yy669:
		YYDEBUG(669, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy670;
		if (yych != 'e') goto yy298;
yy670:
		YYDEBUG(670, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(671, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 956 "Zend/zend_language_scanner.l"
		{
	return T_WHILE;
}
#line 6673 "Zend/zend_language_scanner.c"
yy672:
		YYDEBUG(672, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(673, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 940 "Zend/zend_language_scanner.l"
		{
	return T_IF;
}
#line 6686 "Zend/zend_language_scanner.c"
yy674:
		YYDEBUG(674, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy710;
		if (yych == 'p') goto yy710;
		goto yy298;
yy675:
		YYDEBUG(675, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych <= 'C') {
				if (yych <= 'B') goto yy298;
				goto yy683;
			} else {
				if (yych <= 'R') goto yy298;
				if (yych <= 'S') goto yy681;
				goto yy682;
			}
		} else {
			if (yych <= 'r') {
				if (yych == 'c') goto yy683;
				goto yy298;
			} else {
				if (yych <= 's') goto yy681;
				if (yych <= 't') goto yy682;
				goto yy298;
			}
		}
yy676:
		YYDEBUG(676, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy677;
		if (yych != 's') goto yy298;
yy677:
		YYDEBUG(677, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy678;
		if (yych != 'e') goto yy298;
yy678:
		YYDEBUG(678, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy679;
		if (yych != 't') goto yy298;
yy679:
		YYDEBUG(679, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(680, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1166 "Zend/zend_language_scanner.l"
		{
	return T_ISSET;
}
#line 6742 "Zend/zend_language_scanner.c"
yy681:
		YYDEBUG(681, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy702;
		if (yych == 't') goto yy702;
		goto yy298;
yy682:
		YYDEBUG(682, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy695;
		if (yych == 'e') goto yy695;
		goto yy298;
yy683:
		YYDEBUG(683, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy684;
		if (yych != 'l') goto yy298;
yy684:
		YYDEBUG(684, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy685;
		if (yych != 'u') goto yy298;
yy685:
		YYDEBUG(685, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy686;
		if (yych != 'd') goto yy298;
yy686:
		YYDEBUG(686, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy687;
		if (yych != 'e') goto yy298;
yy687:
		YYDEBUG(687, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy297;
			} else {
				if (yych <= '@') goto yy688;
				if (yych <= 'Z') goto yy297;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy689;
			} else {
				if (yych <= 'z') goto yy297;
				if (yych >= 0x7F) goto yy297;
			}
		}
yy688:
		YYDEBUG(688, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1138 "Zend/zend_language_scanner.l"
		{
	return T_INCLUDE;
}
#line 6800 "Zend/zend_language_scanner.c"
yy689:
		YYDEBUG(689, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy690;
		if (yych != 'o') goto yy298;
yy690:
		YYDEBUG(690, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy691;
		if (yych != 'n') goto yy298;
yy691:
		YYDEBUG(691, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy692;
		if (yych != 'c') goto yy298;
yy692:
		YYDEBUG(692, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy693;
		if (yych != 'e') goto yy298;
yy693:
		YYDEBUG(693, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(694, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1142 "Zend/zend_language_scanner.l"
		{
	return T_INCLUDE_ONCE;
}
#line 6833 "Zend/zend_language_scanner.c"
yy695:
		YYDEBUG(695, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy696;
		if (yych != 'r') goto yy298;
yy696:
		YYDEBUG(696, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'F') goto yy697;
		if (yych != 'f') goto yy298;
yy697:
		YYDEBUG(697, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy698;
		if (yych != 'a') goto yy298;
yy698:
		YYDEBUG(698, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy699;
		if (yych != 'c') goto yy298;
yy699:
		YYDEBUG(699, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy700;
		if (yych != 'e') goto yy298;
yy700:
		YYDEBUG(700, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(701, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1040 "Zend/zend_language_scanner.l"
		{
	return T_INTERFACE;
}
#line 6871 "Zend/zend_language_scanner.c"
yy702:
		YYDEBUG(702, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy703;
		if (yych != 'a') goto yy298;
yy703:
		YYDEBUG(703, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy704;
		if (yych != 'n') goto yy298;
yy704:
		YYDEBUG(704, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy705;
		if (yych != 'c') goto yy298;
yy705:
		YYDEBUG(705, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy706;
		if (yych != 'e') goto yy298;
yy706:
		YYDEBUG(706, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy707;
		if (yych != 'o') goto yy298;
yy707:
		YYDEBUG(707, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'F') goto yy708;
		if (yych != 'f') goto yy298;
yy708:
		YYDEBUG(708, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(709, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 992 "Zend/zend_language_scanner.l"
		{
	return T_INSTANCEOF;
}
#line 6914 "Zend/zend_language_scanner.c"
yy710:
		YYDEBUG(710, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy711;
		if (yych != 'l') goto yy298;
yy711:
		YYDEBUG(711, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy712;
		if (yych != 'e') goto yy298;
yy712:
		YYDEBUG(712, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy713;
		if (yych != 'm') goto yy298;
yy713:
		YYDEBUG(713, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy714;
		if (yych != 'e') goto yy298;
yy714:
		YYDEBUG(714, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy715;
		if (yych != 'n') goto yy298;
yy715:
		YYDEBUG(715, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy716;
		if (yych != 't') goto yy298;
yy716:
		YYDEBUG(716, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy717;
		if (yych != 's') goto yy298;
yy717:
		YYDEBUG(717, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(718, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1048 "Zend/zend_language_scanner.l"
		{
	return T_IMPLEMENTS;
}
#line 6962 "Zend/zend_language_scanner.c"
yy719:
		YYDEBUG(719, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy723;
		if (yych == 'r') goto yy723;
		goto yy298;
yy720:
		YYDEBUG(720, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy721;
		if (yych != 'y') goto yy298;
yy721:
		YYDEBUG(721, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(722, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 928 "Zend/zend_language_scanner.l"
		{
	return T_TRY;
}
#line 6986 "Zend/zend_language_scanner.c"
yy723:
		YYDEBUG(723, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy724;
		if (yych != 'o') goto yy298;
yy724:
		YYDEBUG(724, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'W') goto yy725;
		if (yych != 'w') goto yy298;
yy725:
		YYDEBUG(725, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(726, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 936 "Zend/zend_language_scanner.l"
		{
	return T_THROW;
}
#line 7009 "Zend/zend_language_scanner.c"
yy727:
		YYDEBUG(727, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych == 'Q') goto yy729;
			if (yych <= 'S') goto yy298;
		} else {
			if (yych <= 'q') {
				if (yych <= 'p') goto yy298;
				goto yy729;
			} else {
				if (yych != 't') goto yy298;
			}
		}
		YYDEBUG(728, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy741;
		if (yych == 'u') goto yy741;
		goto yy298;
yy729:
		YYDEBUG(729, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy730;
		if (yych != 'u') goto yy298;
yy730:
		YYDEBUG(730, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy731;
		if (yych != 'i') goto yy298;
yy731:
		YYDEBUG(731, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy732;
		if (yych != 'r') goto yy298;
yy732:
		YYDEBUG(732, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy733;
		if (yych != 'e') goto yy298;
yy733:
		YYDEBUG(733, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy297;
			} else {
				if (yych <= '@') goto yy734;
				if (yych <= 'Z') goto yy297;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy735;
			} else {
				if (yych <= 'z') goto yy297;
				if (yych >= 0x7F) goto yy297;
			}
		}
yy734:
		YYDEBUG(734, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1146 "Zend/zend_language_scanner.l"
		{
	return T_REQUIRE;
}
#line 7074 "Zend/zend_language_scanner.c"
yy735:
		YYDEBUG(735, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy736;
		if (yych != 'o') goto yy298;
yy736:
		YYDEBUG(736, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy737;
		if (yych != 'n') goto yy298;
yy737:
		YYDEBUG(737, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy738;
		if (yych != 'c') goto yy298;
yy738:
		YYDEBUG(738, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy739;
		if (yych != 'e') goto yy298;
yy739:
		YYDEBUG(739, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(740, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1150 "Zend/zend_language_scanner.l"
		{
	return T_REQUIRE_ONCE;
}
#line 7107 "Zend/zend_language_scanner.c"
yy741:
		YYDEBUG(741, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy742;
		if (yych != 'r') goto yy298;
yy742:
		YYDEBUG(742, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy743;
		if (yych != 'n') goto yy298;
yy743:
		YYDEBUG(743, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(744, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 924 "Zend/zend_language_scanner.l"
		{
	return T_RETURN;
}
#line 7130 "Zend/zend_language_scanner.c"
yy745:
		YYDEBUG(745, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych <= 'R') goto yy298;
			if (yych <= 'S') goto yy767;
			goto yy766;
		} else {
			if (yych <= 'r') goto yy298;
			if (yych <= 's') goto yy767;
			if (yych <= 't') goto yy766;
			goto yy298;
		}
yy746:
		YYDEBUG(746, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'A') goto yy758;
			if (yych <= 'N') goto yy298;
			goto yy759;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy298;
				goto yy758;
			} else {
				if (yych == 'o') goto yy759;
				goto yy298;
			}
		}
yy747:
		YYDEBUG(747, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy748;
		if (yych != 'n') goto yy298;
yy748:
		YYDEBUG(748, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych <= 'R') goto yy298;
			if (yych >= 'T') goto yy750;
		} else {
			if (yych <= 'r') goto yy298;
			if (yych <= 's') goto yy749;
			if (yych <= 't') goto yy750;
			goto yy298;
		}
yy749:
		YYDEBUG(749, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy756;
		if (yych == 't') goto yy756;
		goto yy298;
yy750:
		YYDEBUG(750, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy751;
		if (yych != 'i') goto yy298;
yy751:
		YYDEBUG(751, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy752;
		if (yych != 'n') goto yy298;
yy752:
		YYDEBUG(752, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy753;
		if (yych != 'u') goto yy298;
yy753:
		YYDEBUG(753, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy754;
		if (yych != 'e') goto yy298;
yy754:
		YYDEBUG(754, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(755, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1020 "Zend/zend_language_scanner.l"
		{
	return T_CONTINUE;
}
#line 7215 "Zend/zend_language_scanner.c"
yy756:
		YYDEBUG(756, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(757, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 920 "Zend/zend_language_scanner.l"
		{
	return T_CONST;
}
#line 7228 "Zend/zend_language_scanner.c"
yy758:
		YYDEBUG(758, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy763;
		if (yych == 's') goto yy763;
		goto yy298;
yy759:
		YYDEBUG(759, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy760;
		if (yych != 'n') goto yy298;
yy760:
		YYDEBUG(760, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy761;
		if (yych != 'e') goto yy298;
yy761:
		YYDEBUG(761, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(762, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1094 "Zend/zend_language_scanner.l"
		{
	return T_CLONE;
}
#line 7257 "Zend/zend_language_scanner.c"
yy763:
		YYDEBUG(763, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy764;
		if (yych != 's') goto yy298;
yy764:
		YYDEBUG(764, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(765, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1036 "Zend/zend_language_scanner.l"
		{
	return T_CLASS;
}
#line 7275 "Zend/zend_language_scanner.c"
yy766:
		YYDEBUG(766, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy770;
		if (yych == 'c') goto yy770;
		goto yy298;
yy767:
		YYDEBUG(767, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy768;
		if (yych != 'e') goto yy298;
yy768:
		YYDEBUG(768, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(769, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1008 "Zend/zend_language_scanner.l"
		{
	return T_CASE;
}
#line 7299 "Zend/zend_language_scanner.c"
yy770:
		YYDEBUG(770, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy771;
		if (yych != 'h') goto yy298;
yy771:
		YYDEBUG(771, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(772, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 932 "Zend/zend_language_scanner.l"
		{
	return T_CATCH;
}
#line 7317 "Zend/zend_language_scanner.c"
yy773:
		YYDEBUG(773, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy790;
		if (yych == 'n') goto yy790;
		goto yy298;
yy774:
		YYDEBUG(774, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy783;
		if (yych == 'r') goto yy783;
		goto yy298;
yy775:
		YYDEBUG(775, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy776;
		if (yych != 'n') goto yy298;
yy776:
		YYDEBUG(776, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy777;
		if (yych != 'c') goto yy298;
yy777:
		YYDEBUG(777, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy778;
		if (yych != 't') goto yy298;
yy778:
		YYDEBUG(778, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy779;
		if (yych != 'i') goto yy298;
yy779:
		YYDEBUG(779, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy780;
		if (yych != 'o') goto yy298;
yy780:
		YYDEBUG(780, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy781;
		if (yych != 'n') goto yy298;
yy781:
		YYDEBUG(781, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(782, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 916 "Zend/zend_language_scanner.l"
		{
	return T_FUNCTION;
}
#line 7372 "Zend/zend_language_scanner.c"
yy783:
		YYDEBUG(783, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '@') {
				if (yych <= '/') goto yy784;
				if (yych <= '9') goto yy297;
			} else {
				if (yych == 'E') goto yy785;
				if (yych <= 'Z') goto yy297;
			}
		} else {
			if (yych <= 'd') {
				if (yych != '`') goto yy297;
			} else {
				if (yych <= 'e') goto yy785;
				if (yych <= 'z') goto yy297;
				if (yych >= 0x7F) goto yy297;
			}
		}
yy784:
		YYDEBUG(784, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 968 "Zend/zend_language_scanner.l"
		{
	return T_FOR;
}
#line 7400 "Zend/zend_language_scanner.c"
yy785:
		YYDEBUG(785, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy786;
		if (yych != 'a') goto yy298;
yy786:
		YYDEBUG(786, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy787;
		if (yych != 'c') goto yy298;
yy787:
		YYDEBUG(787, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy788;
		if (yych != 'h') goto yy298;
yy788:
		YYDEBUG(788, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(789, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 976 "Zend/zend_language_scanner.l"
		{
	return T_FOREACH;
}
#line 7428 "Zend/zend_language_scanner.c"
yy790:
		YYDEBUG(790, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy791;
		if (yych != 'a') goto yy298;
yy791:
		YYDEBUG(791, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy792;
		if (yych != 'l') goto yy298;
yy792:
		YYDEBUG(792, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(793, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1186 "Zend/zend_language_scanner.l"
		{
	return T_FINAL;
}
#line 7451 "Zend/zend_language_scanner.c"
yy794:
		YYDEBUG(794, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'F') {
			if (yych == 'C') goto yy800;
			if (yych <= 'E') goto yy298;
			goto yy801;
		} else {
			if (yych <= 'c') {
				if (yych <= 'b') goto yy298;
				goto yy800;
			} else {
				if (yych == 'f') goto yy801;
				goto yy298;
			}
		}
yy795:
		YYDEBUG(795, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy798;
		if (yych == 'e') goto yy798;
		goto yy298;
yy796:
		YYDEBUG(796, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(797, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 964 "Zend/zend_language_scanner.l"
		{
	return T_DO;
}
#line 7486 "Zend/zend_language_scanner.c"
yy798:
		YYDEBUG(798, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(799, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 912 "Zend/zend_language_scanner.l"
		{
	return T_EXIT;
}
#line 7499 "Zend/zend_language_scanner.c"
yy800:
		YYDEBUG(800, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy807;
		if (yych == 'l') goto yy807;
		goto yy298;
yy801:
		YYDEBUG(801, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy802;
		if (yych != 'a') goto yy298;
yy802:
		YYDEBUG(802, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy803;
		if (yych != 'u') goto yy298;
yy803:
		YYDEBUG(803, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy804;
		if (yych != 'l') goto yy298;
yy804:
		YYDEBUG(804, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy805;
		if (yych != 't') goto yy298;
yy805:
		YYDEBUG(805, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(806, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1012 "Zend/zend_language_scanner.l"
		{
	return T_DEFAULT;
}
#line 7538 "Zend/zend_language_scanner.c"
yy807:
		YYDEBUG(807, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy808;
		if (yych != 'a') goto yy298;
yy808:
		YYDEBUG(808, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy809;
		if (yych != 'r') goto yy298;
yy809:
		YYDEBUG(809, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy810;
		if (yych != 'e') goto yy298;
yy810:
		YYDEBUG(810, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(811, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 984 "Zend/zend_language_scanner.l"
		{
	return T_DECLARE;
}
#line 7566 "Zend/zend_language_scanner.c"
yy812:
		YYDEBUG(812, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy874;
		if (yych == 'h') goto yy874;
		goto yy298;
yy813:
		YYDEBUG(813, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy868;
		if (yych == 's') goto yy868;
		goto yy298;
yy814:
		YYDEBUG(814, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy864;
		if (yych == 'p') goto yy864;
		goto yy298;
yy815:
		YYDEBUG(815, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy830;
		if (yych == 'd') goto yy830;
		goto yy298;
yy816:
		YYDEBUG(816, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy827;
		if (yych == 'a') goto yy827;
		goto yy298;
yy817:
		YYDEBUG(817, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych == 'I') goto yy818;
			if (yych <= 'S') goto yy298;
			goto yy819;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy298;
			} else {
				if (yych == 't') goto yy819;
				goto yy298;
			}
		}
yy818:
		YYDEBUG(818, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy825;
		if (yych == 't') goto yy825;
		goto yy298;
yy819:
		YYDEBUG(819, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy820;
		if (yych != 'e') goto yy298;
yy820:
		YYDEBUG(820, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy821;
		if (yych != 'n') goto yy298;
yy821:
		YYDEBUG(821, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy822;
		if (yych != 'd') goto yy298;
yy822:
		YYDEBUG(822, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy823;
		if (yych != 's') goto yy298;
yy823:
		YYDEBUG(823, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(824, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1044 "Zend/zend_language_scanner.l"
		{
	return T_EXTENDS;
}
#line 7650 "Zend/zend_language_scanner.c"
yy825:
		YYDEBUG(825, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(826, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 908 "Zend/zend_language_scanner.l"
		{
	return T_EXIT;
}
#line 7663 "Zend/zend_language_scanner.c"
yy827:
		YYDEBUG(827, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy828;
		if (yych != 'l') goto yy298;
yy828:
		YYDEBUG(828, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(829, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1134 "Zend/zend_language_scanner.l"
		{
	return T_EVAL;
}
#line 7681 "Zend/zend_language_scanner.c"
yy830:
		YYDEBUG(830, *YYCURSOR);
		yych = *++YYCURSOR;
		YYDEBUG(-1, yych);
		switch (yych) {
		case 'D':
		case 'd':	goto yy831;
		case 'F':
		case 'f':	goto yy832;
		case 'I':
		case 'i':	goto yy833;
		case 'S':
		case 's':	goto yy834;
		case 'W':
		case 'w':	goto yy835;
		default:	goto yy298;
		}
yy831:
		YYDEBUG(831, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy857;
		if (yych == 'e') goto yy857;
		goto yy298;
yy832:
		YYDEBUG(832, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy849;
		if (yych == 'o') goto yy849;
		goto yy298;
yy833:
		YYDEBUG(833, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'F') goto yy847;
		if (yych == 'f') goto yy847;
		goto yy298;
yy834:
		YYDEBUG(834, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'W') goto yy841;
		if (yych == 'w') goto yy841;
		goto yy298;
yy835:
		YYDEBUG(835, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy836;
		if (yych != 'h') goto yy298;
yy836:
		YYDEBUG(836, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy837;
		if (yych != 'i') goto yy298;
yy837:
		YYDEBUG(837, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy838;
		if (yych != 'l') goto yy298;
yy838:
		YYDEBUG(838, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy839;
		if (yych != 'e') goto yy298;
yy839:
		YYDEBUG(839, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(840, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 960 "Zend/zend_language_scanner.l"
		{
	return T_ENDWHILE;
}
#line 7755 "Zend/zend_language_scanner.c"
yy841:
		YYDEBUG(841, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy842;
		if (yych != 'i') goto yy298;
yy842:
		YYDEBUG(842, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy843;
		if (yych != 't') goto yy298;
yy843:
		YYDEBUG(843, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy844;
		if (yych != 'c') goto yy298;
yy844:
		YYDEBUG(844, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy845;
		if (yych != 'h') goto yy298;
yy845:
		YYDEBUG(845, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(846, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1004 "Zend/zend_language_scanner.l"
		{
	return T_ENDSWITCH;
}
#line 7788 "Zend/zend_language_scanner.c"
yy847:
		YYDEBUG(847, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(848, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 948 "Zend/zend_language_scanner.l"
		{
	return T_ENDIF;
}
#line 7801 "Zend/zend_language_scanner.c"
yy849:
		YYDEBUG(849, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy850;
		if (yych != 'r') goto yy298;
yy850:
		YYDEBUG(850, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '@') {
				if (yych <= '/') goto yy851;
				if (yych <= '9') goto yy297;
			} else {
				if (yych == 'E') goto yy852;
				if (yych <= 'Z') goto yy297;
			}
		} else {
			if (yych <= 'd') {
				if (yych != '`') goto yy297;
			} else {
				if (yych <= 'e') goto yy852;
				if (yych <= 'z') goto yy297;
				if (yych >= 0x7F) goto yy297;
			}
		}
yy851:
		YYDEBUG(851, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 972 "Zend/zend_language_scanner.l"
		{
	return T_ENDFOR;
}
#line 7834 "Zend/zend_language_scanner.c"
yy852:
		YYDEBUG(852, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy853;
		if (yych != 'a') goto yy298;
yy853:
		YYDEBUG(853, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy854;
		if (yych != 'c') goto yy298;
yy854:
		YYDEBUG(854, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy855;
		if (yych != 'h') goto yy298;
yy855:
		YYDEBUG(855, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(856, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 980 "Zend/zend_language_scanner.l"
		{
	return T_ENDFOREACH;
}
#line 7862 "Zend/zend_language_scanner.c"
yy857:
		YYDEBUG(857, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy858;
		if (yych != 'c') goto yy298;
yy858:
		YYDEBUG(858, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy859;
		if (yych != 'l') goto yy298;
yy859:
		YYDEBUG(859, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy860;
		if (yych != 'a') goto yy298;
yy860:
		YYDEBUG(860, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy861;
		if (yych != 'r') goto yy298;
yy861:
		YYDEBUG(861, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy862;
		if (yych != 'e') goto yy298;
yy862:
		YYDEBUG(862, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(863, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 988 "Zend/zend_language_scanner.l"
		{
	return T_ENDDECLARE;
}
#line 7900 "Zend/zend_language_scanner.c"
yy864:
		YYDEBUG(864, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy865;
		if (yych != 't') goto yy298;
yy865:
		YYDEBUG(865, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy866;
		if (yych != 'y') goto yy298;
yy866:
		YYDEBUG(866, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(867, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1170 "Zend/zend_language_scanner.l"
		{
	return T_EMPTY;
}
#line 7923 "Zend/zend_language_scanner.c"
yy868:
		YYDEBUG(868, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy869;
		if (yych != 'e') goto yy298;
yy869:
		YYDEBUG(869, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '@') {
				if (yych <= '/') goto yy870;
				if (yych <= '9') goto yy297;
			} else {
				if (yych == 'I') goto yy871;
				if (yych <= 'Z') goto yy297;
			}
		} else {
			if (yych <= 'h') {
				if (yych != '`') goto yy297;
			} else {
				if (yych <= 'i') goto yy871;
				if (yych <= 'z') goto yy297;
				if (yych >= 0x7F) goto yy297;
			}
		}
yy870:
		YYDEBUG(870, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 952 "Zend/zend_language_scanner.l"
		{
	return T_ELSE;
}
#line 7956 "Zend/zend_language_scanner.c"
yy871:
		YYDEBUG(871, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'F') goto yy872;
		if (yych != 'f') goto yy298;
yy872:
		YYDEBUG(872, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(873, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 944 "Zend/zend_language_scanner.l"
		{
	return T_ELSEIF;
}
#line 7974 "Zend/zend_language_scanner.c"
yy874:
		YYDEBUG(874, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy875;
		if (yych != 'o') goto yy298;
yy875:
		YYDEBUG(875, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy297;
		}
		YYDEBUG(876, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1028 "Zend/zend_language_scanner.l"
		{
	return T_ECHO;
}
#line 7992 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_LOOKING_FOR_PROPERTY:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128,   0,   0, 128,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,   0,   0,   0,   0,   0,   0, 
			  0,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,   0,   0,   0,   0,  64, 
			  0,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,   0,   0,   0,   0,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
		};
		YYDEBUG(877, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= ',') {
			if (yych <= '\f') {
				if (yych <= 0x00) goto yy879;
				if (yych <= 0x08) goto yy887;
				if (yych <= '\n') goto yy881;
				goto yy887;
			} else {
				if (yych <= '\r') goto yy881;
				if (yych == ' ') goto yy881;
				goto yy887;
			}
		} else {
			if (yych <= '^') {
				if (yych <= '-') goto yy883;
				if (yych <= '@') goto yy887;
				if (yych <= 'Z') goto yy885;
				goto yy887;
			} else {
				if (yych <= '`') {
					if (yych <= '_') goto yy885;
					goto yy887;
				} else {
					if (yych <= 'z') goto yy885;
					if (yych <= '~') goto yy887;
					goto yy885;
				}
			}
		}
yy879:
		YYDEBUG(879, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(880, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2104 "Zend/zend_language_scanner.l"
		{ return 0; }
#line 8069 "Zend/zend_language_scanner.c"
yy881:
		YYDEBUG(881, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy893;
yy882:
		YYDEBUG(882, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1057 "Zend/zend_language_scanner.l"
		{
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	HANDLE_NEWLINES(yytext, yyleng);
	return T_WHITESPACE;
}
#line 8086 "Zend/zend_language_scanner.c"
yy883:
		YYDEBUG(883, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '>') goto yy890;
yy884:
		YYDEBUG(884, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1076 "Zend/zend_language_scanner.l"
		{
	yyless(0);
	yy_pop_state(TSRMLS_C);
	goto restart;
}
#line 8100 "Zend/zend_language_scanner.c"
yy885:
		YYDEBUG(885, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy889;
yy886:
		YYDEBUG(886, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1069 "Zend/zend_language_scanner.l"
		{
	yy_pop_state(TSRMLS_C);
	zend_copy_value(zendlval, yytext, yyleng);
	zendlval->type = IS_STRING;
	return T_STRING;
}
#line 8116 "Zend/zend_language_scanner.c"
yy887:
		YYDEBUG(887, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy884;
yy888:
		YYDEBUG(888, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy889:
		YYDEBUG(889, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy888;
		}
		goto yy886;
yy890:
		YYDEBUG(890, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(891, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1065 "Zend/zend_language_scanner.l"
		{
	return T_OBJECT_OPERATOR;
}
#line 8141 "Zend/zend_language_scanner.c"
yy892:
		YYDEBUG(892, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy893:
		YYDEBUG(893, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy892;
		}
		goto yy882;
	}
/* *********************************** */
yyc_ST_LOOKING_FOR_VARNAME:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(894, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '^') {
			if (yych <= 0x00) goto yy896;
			if (yych <= '@') goto yy900;
			if (yych <= 'Z') goto yy898;
			goto yy900;
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy898;
				goto yy900;
			} else {
				if (yych <= 'z') goto yy898;
				if (yych <= '~') goto yy900;
				goto yy898;
			}
		}
yy896:
		YYDEBUG(896, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(897, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2104 "Zend/zend_language_scanner.l"
		{ return 0; }
#line 8216 "Zend/zend_language_scanner.c"
yy898:
		YYDEBUG(898, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy903;
yy899:
		YYDEBUG(899, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1348 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, yytext, yyleng);
	zendlval->type = IS_STRING;
	yy_pop_state(TSRMLS_C);
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	return T_STRING_VARNAME;
}
#line 8233 "Zend/zend_language_scanner.c"
yy900:
		YYDEBUG(900, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(901, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1357 "Zend/zend_language_scanner.l"
		{
	yyless(0);
	yy_pop_state(TSRMLS_C);
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	goto restart;
}
#line 8246 "Zend/zend_language_scanner.c"
yy902:
		YYDEBUG(902, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy903:
		YYDEBUG(903, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy902;
		}
		goto yy899;
	}
/* *********************************** */
yyc_ST_NOWDOC:
	{
		static const unsigned char yybm[] = {
			  0,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  32,  16,  16,  64,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144,  16,  16,  16,  16,  16,  16, 
			 16, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144,  16,  16,  16,  16, 144, 
			 16, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144,  16,  16,  16,  16, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
		};
		YYDEBUG(904, *YYCURSOR);
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy908;
		}
		if (yych <= 0x00) goto yy906;
		if (yych <= '\f') goto yy911;
		goto yy913;
yy906:
		YYDEBUG(906, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(907, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2104 "Zend/zend_language_scanner.l"
		{ return 0; }
#line 8312 "Zend/zend_language_scanner.c"
yy908:
		YYDEBUG(908, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(909, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy908;
		}
		if (yych <= 0x00) goto yy910;
		if (yych <= '\f') goto yy920;
		goto yy922;
yy910:
		YYDEBUG(910, *YYCURSOR);
yy911:
		YYDEBUG(911, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(912, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy911;
		}
		if (yych <= 'Z') {
			if (yych <= '\f') {
				if (yych <= 0x00) goto yy910;
				goto yy908;
			} else {
				if (yych <= '\r') goto yy913;
				if (yych <= '@') goto yy908;
				goto yy915;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy915;
				goto yy908;
			} else {
				if (yych <= 'z') goto yy915;
				if (yych <= '~') goto yy908;
				goto yy915;
			}
		}
yy913:
		YYDEBUG(913, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(914, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy911;
		}
		if (yych <= 'Z') {
			if (yych <= '\f') {
				if (yych <= 0x00) goto yy910;
				goto yy908;
			} else {
				if (yych <= '\r') goto yy913;
				if (yych <= '@') goto yy908;
			}
		} else {
			if (yych <= '`') {
				if (yych != '_') goto yy908;
			} else {
				if (yych <= 'z') goto yy915;
				if (yych <= '~') goto yy908;
			}
		}
yy915:
		YYDEBUG(915, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(916, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy915;
		}
		if (yych <= '\f') {
			if (yych <= 0x00) goto yy910;
			if (yych == '\n') goto yy918;
			goto yy908;
		} else {
			if (yych <= '\r') goto yy918;
			if (yych != ';') goto yy908;
		}
		YYDEBUG(917, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy908;
		}
		if (yych <= 0x00) goto yy910;
yy918:
		YYDEBUG(918, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(919, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2052 "Zend/zend_language_scanner.l"
		{
	char *end = yytext + yyleng - 1;

	if (end[-1] == ';') {
		end--;
		yyleng--;
	}

	if (yyleng > CG(heredoc_len) && !memcmp(end - CG(heredoc_len), CG(heredoc), CG(heredoc_len))) {
		int len = yyleng - CG(heredoc_len) - 2; /* 2 for newline before and after label */

		/* May have matched fooLABEL; make sure there's a newline before it */
		if (yytext[len] != '\n') {
			if (yytext[len] != '\r') {
				yyless(yyleng - 1);
				yymore();
			}
		} else if (len > 0 && yytext[len - 1] == '\r') {
			len--; /* Windows newline */
		}

		/* Go back before label, to match in ST_END_HEREDOC state. yytext will include
		 * newline before label, for zend_highlight/strip, tokenizer, etc. */
		yyless(yyleng - CG(heredoc_len) - 1); /* 1 for newline after label */

		CG(increment_lineno) = 1; /* For newline before label */
		BEGIN(ST_END_HEREDOC);

		zend_copy_value(zendlval, yytext, len);
		zendlval->type = IS_STRING;
		HANDLE_NEWLINES(yytext, len);
		return T_ENCAPSED_AND_WHITESPACE;
	} else {
		/* Go back to end of label, so the next match works correctly in case of
		 * another label at the beginning of the next line */
		yyless(yyleng - 1);
		yymore();
	}
}
#line 8450 "Zend/zend_language_scanner.c"
yy920:
		YYDEBUG(920, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(921, *YYCURSOR);
		if (yych <= '@') {
			if (yych <= '\n') {
				if (yych <= 0x00) goto yy910;
				if (yych <= '\t') goto yy908;
				goto yy920;
			} else {
				if (yych != '\r') goto yy908;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy915;
				if (yych <= '^') goto yy908;
				goto yy915;
			} else {
				if (yych <= '`') goto yy908;
				if (yych <= 'z') goto yy915;
				if (yych <= '~') goto yy908;
				goto yy915;
			}
		}
yy922:
		YYDEBUG(922, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(923, *YYCURSOR);
		if (yych <= '@') {
			if (yych <= '\n') {
				if (yych <= 0x00) goto yy910;
				if (yych <= '\t') goto yy908;
				goto yy920;
			} else {
				if (yych == '\r') goto yy922;
				goto yy908;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy915;
				if (yych <= '^') goto yy908;
				goto yy915;
			} else {
				if (yych <= '`') goto yy908;
				if (yych <= 'z') goto yy915;
				if (yych <= '~') goto yy908;
				goto yy915;
			}
		}
	}
/* *********************************** */
yyc_ST_ONE_LINE_COMMENT:
	{
		static const unsigned char yybm[] = {
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0, 128, 128,   0, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128,   0, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(924, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 128) {
			goto yy932;
		}
		if (yych <= '\r') {
			if (yych <= 0x00) goto yy926;
			if (yych <= '\f') goto yy935;
			goto yy936;
		} else {
			if (yych <= '=') goto yy928;
			if (yych <= '>') goto yy930;
			goto yy931;
		}
yy926:
		YYDEBUG(926, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(927, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2104 "Zend/zend_language_scanner.l"
		{ return 0; }
#line 8564 "Zend/zend_language_scanner.c"
yy928:
		YYDEBUG(928, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '>') goto yy940;
yy929:
		YYDEBUG(929, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1715 "Zend/zend_language_scanner.l"
		{
	yymore();
}
#line 8576 "Zend/zend_language_scanner.c"
yy930:
		YYDEBUG(930, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy929;
yy931:
		YYDEBUG(931, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy940;
		goto yy929;
yy932:
		YYDEBUG(932, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(933, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy932;
		}
		if (yych >= 0x01) goto yy939;
yy934:
		YYDEBUG(934, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1719 "Zend/zend_language_scanner.l"
		{
	switch (yytext[yyleng-1]) {
		case '?': case '%': case '>':
			yyless(yyleng-1);
			yymore();
			break;
		case '\n':
			CG(zend_lineno)++;
			/* intentional fall through */
		default:
			zendlval->value.str.val = yytext; /* no copying - intentional */
			zendlval->value.str.len = yyleng;
			zendlval->type = IS_STRING;
			BEGIN(ST_IN_SCRIPTING);
			return T_COMMENT;
	}
}
#line 8617 "Zend/zend_language_scanner.c"
yy935:
		YYDEBUG(935, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy934;
yy936:
		YYDEBUG(936, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '\n') goto yy934;
		YYDEBUG(937, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(938, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1737 "Zend/zend_language_scanner.l"
		{
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	BEGIN(ST_IN_SCRIPTING);
	CG(zend_lineno)++;
	return T_COMMENT;
}
#line 8639 "Zend/zend_language_scanner.c"
yy939:
		YYDEBUG(939, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy934;
yy940:
		YYDEBUG(940, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(941, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1746 "Zend/zend_language_scanner.l"
		{
	if (CG(asp_tags) || yytext[yyleng-2] != '%') { /* asp comment? */
		zendlval->value.str.val = yytext; /* no copying - intentional */
		zendlval->value.str.len = yyleng-2;
		zendlval->type = IS_STRING;
		yyless(yyleng - 2);
		BEGIN(ST_IN_SCRIPTING);
		return T_COMMENT;
	} else {
		yymore();
	}
}
#line 8662 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_VAR_OFFSET:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			224, 224, 224, 224, 224, 224, 224, 224, 
			224, 224,   0,   0,   0,   0,   0,   0, 
			  0, 160, 160, 160, 160, 160, 160,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,   0,   0,   0,   0,  32, 
			  0, 160, 160, 160, 160, 160, 160,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,   0,   0,   0,   0,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
		};
		YYDEBUG(942, *YYCURSOR);
		YYFILL(3);
		yych = *YYCURSOR;
		if (yych <= '/') {
			if (yych <= 0x1F) {
				if (yych <= '\n') {
					if (yych <= 0x00) goto yy944;
					if (yych <= 0x08) goto yy958;
					goto yy954;
				} else {
					if (yych == '\r') goto yy954;
					goto yy958;
				}
			} else {
				if (yych <= '#') {
					if (yych <= ' ') goto yy954;
					if (yych <= '"') goto yy953;
					goto yy954;
				} else {
					if (yych <= '$') goto yy949;
					if (yych == '\'') goto yy954;
					goto yy953;
				}
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '@') {
					if (yych <= '0') goto yy946;
					if (yych <= '9') goto yy948;
					goto yy953;
				} else {
					if (yych <= 'Z') goto yy956;
					if (yych <= '[') goto yy953;
					goto yy954;
				}
			} else {
				if (yych <= '_') {
					if (yych <= ']') goto yy951;
					if (yych <= '^') goto yy953;
					goto yy956;
				} else {
					if (yych <= '`') goto yy953;
					if (yych <= 'z') goto yy956;
					if (yych <= '~') goto yy953;
					goto yy956;
				}
			}
		}
yy944:
		YYDEBUG(944, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(945, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2104 "Zend/zend_language_scanner.l"
		{ return 0; }
#line 8756 "Zend/zend_language_scanner.c"
yy946:
		YYDEBUG(946, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'W') {
			if (yych <= '/') goto yy947;
			if (yych <= '9') goto yy969;
		} else {
			if (yych <= 'X') goto yy967;
			if (yych == 'x') goto yy967;
		}
yy947:
		YYDEBUG(947, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1407 "Zend/zend_language_scanner.l"
		{ /* Offset could be treated as a long */
	if (yyleng < MAX_LENGTH_OF_LONG - 1 || (yyleng == MAX_LENGTH_OF_LONG - 1 && strcmp(yytext, long_min_digits) < 0)) {
		zendlval->value.lval = strtol(yytext, NULL, 10);
		zendlval->type = IS_LONG;
	} else {
		zendlval->value.str.val = (char *)estrndup(yytext, yyleng);
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
	}
	return T_NUM_STRING;
}
#line 8783 "Zend/zend_language_scanner.c"
yy948:
		YYDEBUG(948, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy966;
yy949:
		YYDEBUG(949, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy950;
			if (yych <= 'Z') goto yy962;
			if (yych >= '_') goto yy962;
		} else {
			if (yych <= '`') goto yy950;
			if (yych <= 'z') goto yy962;
			if (yych >= 0x7F) goto yy962;
		}
yy950:
		YYDEBUG(950, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1690 "Zend/zend_language_scanner.l"
		{
	/* Only '[' can be valid, but returning other tokens will allow a more explicit parse error */
	return yytext[0];
}
#line 8808 "Zend/zend_language_scanner.c"
yy951:
		YYDEBUG(951, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(952, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1685 "Zend/zend_language_scanner.l"
		{
	yy_pop_state(TSRMLS_C);
	return ']';
}
#line 8819 "Zend/zend_language_scanner.c"
yy953:
		YYDEBUG(953, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy950;
yy954:
		YYDEBUG(954, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(955, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1695 "Zend/zend_language_scanner.l"
		{
	/* Invalid rule to return a more explicit parse error with proper line number */
	yyless(0);
	yy_pop_state(TSRMLS_C);
	ZVAL_EMPTY_STRING(zendlval); /* Empty since it won't be used */
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 8837 "Zend/zend_language_scanner.c"
yy956:
		YYDEBUG(956, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy961;
yy957:
		YYDEBUG(957, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1703 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, yytext, yyleng);
	zendlval->type = IS_STRING;
	return T_STRING;
}
#line 8852 "Zend/zend_language_scanner.c"
yy958:
		YYDEBUG(958, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(959, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2106 "Zend/zend_language_scanner.l"
		{
	zend_error(E_COMPILE_WARNING,"Unexpected character in input:  '%c' (ASCII=%d) state=%d", yytext[0], yytext[0], YYSTATE);
	goto restart;
}
#line 8863 "Zend/zend_language_scanner.c"
yy960:
		YYDEBUG(960, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy961:
		YYDEBUG(961, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy960;
		}
		goto yy957;
yy962:
		YYDEBUG(962, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(963, *YYCURSOR);
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy962;
			} else {
				if (yych <= '@') goto yy964;
				if (yych <= 'Z') goto yy962;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy962;
			} else {
				if (yych <= 'z') goto yy962;
				if (yych >= 0x7F) goto yy962;
			}
		}
yy964:
		YYDEBUG(964, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1679 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 8905 "Zend/zend_language_scanner.c"
yy965:
		YYDEBUG(965, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy966:
		YYDEBUG(966, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy965;
		}
		goto yy947;
yy967:
		YYDEBUG(967, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 128) {
			goto yy972;
		}
		YYDEBUG(968, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy947;
yy969:
		YYDEBUG(969, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(970, *YYCURSOR);
		if (yych <= '/') goto yy971;
		if (yych <= '9') goto yy969;
yy971:
		YYDEBUG(971, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1419 "Zend/zend_language_scanner.l"
		{ /* Offset must be treated as a string */
	zendlval->value.str.val = (char *)estrndup(yytext, yyleng);
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	return T_NUM_STRING;
}
#line 8944 "Zend/zend_language_scanner.c"
yy972:
		YYDEBUG(972, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(973, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy972;
		}
		goto yy971;
	}
}
#line 2111 "Zend/zend_language_scanner.l"

}
